<?php
 Session_Start () ;
 Include ("../../include/garennes.cfg") ;
 Include ("../../include/init.php") ;
 Include ("../include/config.inc") ;
 verif_droits ($droit_courant, $_SESSION ["code"]) ;
 
 $table = var_courante ("table", 0, null) ;
 $etape = var_courante ("etape", 0, null) ;
 $numero_etape = var_courante ("numero_etape", 0, 1) ;
 
 $id_classe = var_courante ("id_classe", 0, 0) ;
 $professeur = var_courante ("professeur", 0, 0) ;
 $discipline = var_courante ("discipline", 0, 0) ;
 $id_service_prof = var_courante ("id_service_prof", 0, 0) ;
 $periode = var_courante ("periode", 0, 0) ;
 
 $menu = var_courante ("menu", 0, 0) ;
 $tt_cl = var_courante ("tt_cl", 0, 0) ;
 
 $type_discipline = champ_disc_type_discipline_parid ($discipline) ;
 $type_moyenne = champ_disc_type_moyenne_parid ($discipline) ;
 If ($type_moyenne == 0) { $note_max = var_courante ("note_max", 0, $note_par_defaut) ; } Else { $note_max = 100 ; }
 
 $nombre_etapes = 4 ;
 $repere_obligatoire = "**" ;
 $repere_non_obligatoire = "  " ;
 $millesime = millesime (0) ;
 
 $nom_table = "imp_texte" ; //.Session_Id () ;
 $nom_table_prepa = "imp_prepa" ; //.Session_Id () ;
 
 /*
 * Fonction d'evaluation d'un champ s'il contient une variable
 * @param string $c Champ a evaluer
 * @return mixed Evaluation
 */
 Function evaluation_champ ($c)
  {
   Global $gestion ;
   If (SubStr ($c, 0, 1) == "@")
    {
     $c = SubStr ($c, 1, StrLen ($c)-1) ;
     $f = FOpen ("../../tmp/".Session_Id ().".tmp", "w") ;
     FPuts ($f, "<?php ") ;
     FPuts ($f, "\$c=".$c."; ") ;
     FPuts ($f, "?".">") ;
     FClose ($f) ;
     Include ("../../tmp/".Session_Id ().".tmp") ;
     UnLink ("../../tmp/".Session_Id ().".tmp") ;
    }
   Return $c ;
  }
 
 /**
 * Fonction d'evaluation de la ressemblance entre deux textes
 * @param string $nom1 Nom 1 a comparer
 * @param string $nom2 Nom 2 a comparer
 * @return Int Pourcentage de ressemblance 
 */
 Function ressemblance ($nom1, $nom2)
  {
   //$pourcentage = 0 ;
   $taille1 = StrLen ($nom1) ;
   $taille2 = StrLen ($nom2) ;
   $car1 = Array ("é","è","ê","ë","É","È","Ê","Ë","à","â","À","Â","ù","ü","û","Ù","Ü","Û","ï","î","ì","Ï","Î","Ì","ç","Ç") ;
   $car2 = Array ("e","e","e","e","e","e","e","e","a","a","a","a","u","u","u","u","u","u","i","i","i","i","i","i","c","c") ;
   $nom1 = Str_Replace ($car1, $car2, $nom1) ;
   $nom2 = Str_Replace ($car1, $car2, $nom2) ;
   $position1 = $position2 = $position3 = 0 ;
   While (($position1 < StrLen ($nom1)) Or ($position1 < StrLen ($nom2)))
    {
     If (($nom1 [$position1] == $nom2 [$position1]) Or (StrToUpper ($nom1 [$position1]) == StrToUpper ($nom2 [$position1])))
      {
       $table1 [$position2] = $nom1 [$position1] ;
       $table2 [$position2] = $nom2 [$position1] ;	 
      }
     Else
      {
       If (StrLen ($nom1) > StrLen ($nom2))
        {
         $table1 [$position2] = $nom1 [$position1] ;
         $table2 [$position2] = " " ;
         $nom2 = SubStr ($nom2, 0, $position2)." ".SubStr ($nom2, $position2, StrLen ($nom2)-$position2) ;
        }
       Else
        {
         $table1 [$position2] = " " ;
         $table2 [$position2] = $nom2 [$position1] ;
         $nom1 = SubStr ($nom1, 0, $position2)." ".SubStr ($nom1, $position2, StrLen ($nom1)-$position2) ;
	}
      }
     //echo $position1."->".$nom1."(".StrLen ($nom1).")|".$nom2."(".StrLen ($nom2).")|".$position2."<br>" ;
     $position1++ ;
     $position2++ ;
    } 
   If (SizeOf ($table1) > SizeOf ($table2)) { $taille = SizeOf ($table1) ; } Else { $taille = SizeOf ($table2) ; }
   //echo SizeOf ($table1)."|".SizeOf ($table2)."->".$taille."<br>" ;
   $identique = 0 ;
   For ($i = 0 ; $i < $taille ; $i++)
    {
     //echo $table1 [$i]."==".$table2 [$i]."?->" ;
     If (($table1 [$i] == $table2 [$i]) Or (StrToUpper ($table1 [$i]) == StrToUpper ($table2 [$i]))) { $identique++ ; }
     //echo $identique."<br>" ;
    }
   $pourcentage = Round (100*$identique/$taille) ;
   Return $pourcentage ;
  }
 
 $resultats = SQL_commande ("SELECT * FROM menus WHERE numero='".$droit_courant."' AND ordre='0'", $id_sql) ;
 $l = SQL_tableau_associatif ($resultats, "") ; 
 Echo "<html><head>" ;
 entete_html ("Garennes", "fenetre", 1) ;
 Echo styles ("none", "none", "none", $l ["lien"], "none") ;
 If (!IsSet ($numero_etape) Or ((integer)$numero_etape <= 1))
  {
   Echo "<script type=\"text/javascript\">" ;
   Echo "function active_options(){" ;
   Echo "document.getElementById('separateur').disabled=0;" ;
   Echo "document.getElementById('delimiteur').disabled=0;" ;
   Echo "document.getElementById('format_date').disabled=0;" ;
   Echo "}" ;
   Echo "function selection_options(s,d,f){" ;
   Echo "document.getElementById('separateur').value=s;" ;
   Echo "document.getElementById('delimiteur').value=d;" ;
   Echo "document.getElementById('format_date').value=f;" ;
   Echo "document.getElementById('separateur').disabled=1;" ;
   Echo "document.getElementById('delimiteur').disabled=1;" ;
   Echo "document.getElementById('format_date').disabled=1;" ;
   Echo "}" ;
   Echo "</script>" ;
  }
 Echo "</head>" ;
 
 Echo "<body background=\"../images/fond.png\" text=\"#000000\" onContextMenu=\"return false\">" ;
 Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border-collapse:collapse\">" ;
 Echo "<tr><td> </td><td align=\"center\"><font color=\"#0000FF\">Importations&nbsp;de&nbsp;notes&nbsp;&agrave;&nbsp;partir&nbsp;d'un&nbsp;fichier&nbsp;au&nbsp;format&nbsp;CSV&nbsp;</font></td>" ;
 Echo "<td align=\"right\"><a href=\"javascript:window.close()\"><img src=\"../../images/quitter.png\" border=\"0\" title=\"Fermer la fen&ecirc;tre...\"></a></td></tr></table>" ;
 
 If (IsSet ($numero_etape) And ((integer)$numero_etape > 1))
  {
   If (IsSet ($etape) And ((integer)$etape > 0))
    {
     Switch ((integer)$etape)
      {
       // Enregistrement du contenu du fichier transmis et Analyse du fichier + Association des champs
       Case 1 : // Recuperation du fichier et analyse
                $entete = var_courante ("entete", 0, 0) ; 
		$nombre = var_courante ("nombre", 0, 0) ;
		$nombre_champs = var_courante ("nombre_champs", 0, null) ;
                $separateur = var_courante ("separateur", 0, $separateurs [0][1]) ;
                $delimiteur = var_courante ("delimiteur", 0, 1) ;
                $format_date = var_courante ("format_date", 0, 0) ;
		
		$tel = var_courante ("tel", 0, null) ;
                $cs1 = var_courante ("cs1", 0, null) ;
                $ts1 = var_courante ("ts1", 0, null) ; If (IsSet ($ts1)) { $ts1 = Str_Replace ("\'", "'", $ts1) ; }
                $cs2 = var_courante ("cs2", 0, null) ;
                $ts2 = var_courante ("ts2", 0, null) ; If (IsSet ($ts1)) { $ts2 = Str_Replace ("\'", "'", $ts2) ; }
		
                $ok = 0 ;
                If ($_FILES ["fichier"]["error"] == 0)
                 {
                  If (Is_UpLoaded_File ($_FILES ["fichier"]["tmp_name"]))
                   {
	            $f = File ($_FILES ["fichier"]["tmp_name"]) ;
		    If (test_presence_table ($nom_table, $id_sql) == 0)
		     {
                      // Destruction de la table
                      //$ok = SQL_commande ("DROP TABLE ".$nom_table, $id_sql) ;
                      // Creation de la table
                      $ok = SQL_commande ("CREATE TABLE ".$nom_table." (id_imp_texte INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,ligne TEXT NOT NULL,PRIMARY KEY(id_imp_texte))", $id_sql) ;
		     }
		    Else
		     {
		      $ok = SQL_commande ("DELETE FROM ".$nom_table." WHERE ligne LIKE '".Session_Id ().$separateurs [$separateur][0]."%'", $id_sql) ;
		     }
                    // Insertion
                    $nombre_champs = 0 ;
                    $requete = "INSERT INTO ".$nom_table." (ligne) VALUES " ;
                    $ligne = Explode ($separateurs [$separateur][0], Chop ($f [0])) ;
                    $nombre_champs = SizeOf ($ligne) ;
                    For ($i = 0 ; $i < SizeOf ($f) ; $i++)
                     {
                      If ($i > 0) { $requete .= "," ; }
                      $requete .= "('".Session_Id ().$separateurs [$separateur][0].Str_Replace ("'", "\\'", Chop ($f [$i]))."')" ;
                      //$ligne = Explode ($separateurs [$separateur][0], $f [0]) ;
                      //If (SizeOf ($ligne) > $nombre_champs) { $nombre_champs = SizeOf ($ligne) ; }
                     }
                    $ok = SQL_commande ($requete, $id_sql) ;
                    $resultats = SQL_commande ("SELECT COUNT(*) FROM ".$nom_table." WHERE ligne LIKE '".Session_Id ().$separateurs [$separateur][0]."%'", $id_sql) ;
                    $r = SQL_ligne_suivante ($resultats) ;
                    $nombre_lignes = $r [0] ;
                    $ok = 1 ;
                   }
                 } 
                If (($ok == 0) And (!IsSet ($tel)))
                 {
                  Switch ((integer)$_FILES ["fichier"]["error"])
                   {
                     Case 1 : $message = "Le param&egrave;tre <i>upload_max_filesize</i> dans <b>php.ini</b> est trop petit." ; Break ;
                     Case 2 : $message = "Le param&egrave;tre HTML, <i>MAX_FILE_SIZE</i> est trop petit." ; Break ;
                     Case 3 : $message = "Le transfert du fichier ne s'est pas effectu&eacute; dans sa totalit&eacute;." ; Break ;
                     Case 4 : $message = "Aucun transfert de fichier ne s'est effectu&eacute;." ; Break ;
                    Default : $message = "Erreur lors du t&eacute;l&eacute;chargement du fichier : Corrompu ??" ; Break ;
                   }
                 }
		ElseIf (IsSet ($tel))
		 {
		  // Reprise de la table actuelle
		  $resultats = SQL_commande ("SELECT COUNT(*) FROM ".$nom_table." WHERE ligne LIKE '".Session_Id ().$separateurs [$separateur][0]."%'", $id_sql) ;
                  $r = SQL_ligne_suivante ($resultats) ;
                  $nombre_lignes = $r [0] ;
		  $ok = 1 ;
		 }
                Echo "<script type=\"text/javascript\">function valide(){document.insertion.submit();}</script>" ;
                Echo "<form action=\"./importation_notes.php\" name=\"insertion\" method=\"post\">" ;
                Echo "<input type=\"hidden\" name=\"etape\" value=\"".($etape+1)."\">" ;
                Echo "<input type=\"hidden\" name=\"numero_etape\" value=\"".($numero_etape+1)."\">" ;
                Echo "<input type=\"hidden\" name=\"table\" value=\"".$table."\">" ;
                Echo "<input type=\"hidden\" name=\"entete\" value=\"".$entete."\">" ;
                Echo "<input type=\"hidden\" name=\"separateur\" value=\"".$separateur."\">" ;
                Echo "<input type=\"hidden\" name=\"delimiteur\" value=\"".$delimiteur."\">" ;
                Echo "<input type=\"hidden\" name=\"format_date\" value=\"".$format_date."\">" ;
		Echo "<input type=\"hidden\" name=\"id_classe\" value=\"".$id_classe."\">" ;
                Echo "<input type=\"hidden\" name=\"professeur\" value=\"".$professeur."\">" ;
		Echo "<input type=\"hidden\" name=\"discipline\" value=\"".$discipline."\">" ;
                Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
                Echo "<input type=\"hidden\" name=\"periode\" value=\"".$periode."\">" ;
                Echo "<input type=\"hidden\" name=\"menu\" value=\"".$menu."\">" ;
		Echo "<input type=\"hidden\" name=\"tt_cl\" value=\"".$tt_cl."\">" ;
		Echo "<input type=\"hidden\" name=\"nombre_champs\" value=\"".$nombre_champs."\">" ;
		$titre_fenetre = "&nbsp;<b>Importation&nbsp;.</b>&nbsp;(".$numero_etape."/".$nombre_etapes.")" ;
                $non_centrer = 0 ;
                Include ("../include/debut_theme.inc") ;
                Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border-collapse:collapse\">" ;
                Echo "<tr><td>&nbsp;</td></tr>" ;
                If (IsSet ($message) And ($message != ""))
                 {
                  Echo "<tr><td>&nbsp;<b>ATTENTION&nbsp;:</b>&nbsp;</td>" ;
                  Echo "<tr><td>&nbsp;".$message."&nbsp;</td>" ;
                  Echo "<tr><td>&nbsp;<br>&nbsp;<br>&nbsp;Contactez&nbsp;votre&nbsp;administrateur&nbsp;Garennes&nbsp;pour&nbsp;r&egrave;gler&nbsp;ce&nbsp;probl&egrave;me&nbsp;!&nbsp;</td>" ;
                  Echo "<tr><td>&nbsp;</td>" ;
                  Echo "<tr><td>&nbsp;<a href=\"./importation_csv.php?etape=".($etape-1)."&numero_etape=".($numero_etape-1)."&table=".$table."&entete=".$entete."&separateur=".$separateur."&delimiteur=".$delimiteur."\" title=\"Choix de l'&eacute;tape...\">&nbsp;<--PR&Eacute;C&Eacute;DENT&nbsp;</a>&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;</td>" ;
                 }
                Else
                 {
                  Echo "<tr><td>&nbsp;Nombre&nbsp;de&nbsp;champs&nbsp;d&eacute;tect&eacute;s&nbsp;:&nbsp;<b>".$nombre_champs."</b>&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;Nombre&nbsp;d'enregistrements&nbsp;d&eacute;tect&eacute;s&nbsp;:&nbsp;<b>".$nombre_lignes."</b>&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;<b>Les&nbsp;associations&nbsp;marqu&eacute;es&nbsp;de&nbsp;".$repere_obligatoire."&nbsp;sont&nbsp;OBLIGATOIRES.</b></td></tr>" ;
                  Echo "<tr><td>&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;<b>Association&nbsp;des&nbsp;champs&nbsp;&agrave;&nbsp;importer</b>&nbsp;:&nbsp;</td></tr>" ;
                  Echo "<tr><td align=\"center\">&nbsp;" ;
                  Echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border:1px solid #000000;border-collapse:collapse\">" ;
                  Echo "<tr bgcolor=\"".$l ["lien"]."\"><td align=\"center\"><b>&nbsp;Champ&nbsp;</b></td>" ;
                  If ($entete == 1) { Echo "<td align=\"center\"><b>&nbsp;Propri&eacute;t&eacute;s&nbsp;</b></td>" ; }
                  Echo "<td><b>&nbsp;Exemple&nbsp;</b></td><td align=\"center\"><b>&nbsp;Associ&eacute;&nbsp;&agrave;&nbsp;</b></td></tr>" ;
		  
		  // Faire selection des proprietes entre deux lignes
		  // Faire attribution des entetes
		  // Faire attribution des colonnes de notes : Colonne NOM, Colonne PRENOM (optionnelle), Colonne DateDeNaissance (optionnelle) et ou commence la colonne des notes
		  
                  $entetes = SQL_commande ("SELECT ligne FROM ".$nom_table." WHERE id_imp_texte=".$entete." LIMIT 1", $id_sql) ;
                  $ligne_entetes = SQL_ligne_suivante ($entetes) ;
                  $le = Explode ($separateurs [$separateur][0], $ligne_entetes [0]) ;
		  
                  $resultat = SQL_commande ("SELECT ligne FROM ".$nom_table." WHERE id_imp_texte>".$entete." LIMIT 1", $id_sql) ;
                  If (SQL_nbr_lignes ($resultat) != 1) { $resultat = SQL_commande ("SELECT ligne FROM ".$nom_table, $id_sql) ; }
                  $ligne = SQL_ligne_suivante ($resultat) ;
                  $ls = Explode ($separateurs [$separateur][0], $ligne [0]) ;
		  
		  If (SizeOf ($ls) > $nombre_champs) { $nombre = $nombre_champs ; } Else { $nombre = SizeOf ($ls) ; }
                  Echo "<input type=\"hidden\" name=\"nombre\" value=\"".$nombre."\">" ;
                  For ($i = 0 ; $i < $nombre ; $i++)
                   {
                    $ls [$i] = Chop ($ls [$i]) ;
                    Echo "<tr" ; If ($i%1 == 1) { Echo " bgcolor=\"".$l ["nom"]."\"" ; }
		    Echo "><td align=\"center\">&nbsp;".($i+1)."&nbsp;</td>" ;
                    If ($entete == 1) { Echo "<td align=\"center\">&nbsp;".$le [$i]."&nbsp;</td>" ; }
                    If ($delimiteur > 1)
                     {
		      If ($delimiteur != 2) { $car_delimiteur = SubStr ($delimiteurs [$delimiteur][1], 0, 1) ; } Else { $car_delimiteur = "\"" ; }
                      If (SubStr ($ls [$i], 0, 1) == $car_delimiteur) { $ls [$i] = SubStr ($ls [$i], 1, StrLen ($ls [$i])-1) ; }
                      If (SubStr ($ls [$i], StrLen ($l [$i])-1, 1) == $car_delimiteur) { $ls [$i] = SubStr ($ls [$i], 0, StrLen ($ls [$i])-1) ; }
                     }
		    $c = var_courante ("c".$i, 0, null) ;
                    Echo "<td>&nbsp;".$ls [$i]."&nbsp;</td>" ;
                    Echo "<td><select name=\"c".$i."\"><option value=\"0\"></option>" ;
		    Echo "<option value=\"2\"" ; If (IsSet ($c) And ($c == 2)) { Echo " selected" ; } ElseIf (($entete == 1) And ($le [$i] == "Nom")) { Echo " selected" ; }
		    Echo ">".$repere_obligatoire."Nom Pr&eacute;nom</option>" ;
		    Echo "<option value=\"3\"" ; If (IsSet ($c) And ($c == 3)) { Echo " selected" ; } ElseIf (($entete == 1) And ($le [$i] == "Prnom")) { Echo " selected" ; }
		    Echo ">".$repere_obligatoire."Pr&eacute;nom</option>" ;
		    Echo "<option value=\"4\"" ; If (IsSet ($c) And ($c == 4)) { Echo " selected" ; } ElseIf (($entete == 1) And ($le [$i] == "Dnaiss")) { Echo " selected" ; }
		    Echo ">".$repere_obligatoire."Date de naissance</option>" ;
		    Echo "<option value=\"5\"" ; If (IsSet ($c) And ($c == 5)) { Echo " selected" ; } ElseIf (($entete == 1) And ($le [$i] == "Divcod") And ($tt_cl == 0)) { Echo " selected" ; }
		    Echo ">Classe</option>" ;
                    Echo "<option value=\"1\"" ; If (IsSet ($c) And ($c == 1)) { Echo " selected" ; }
		    Echo ">".$repere_obligatoire."Note</option>" ;
                    Echo "</select>&nbsp;</td></tr>" ;
                   }
                  Echo "</table>&nbsp;</td></tr>" ;
                  // Condition supplementaire 1
                  $champ_s = Explode (";", $imp_texte [$table][0][9]) ;
                  If (IsSet ($champ_s [1])) { $champ_1 = Explode ("->", $champ_s [0]) ; } Else { $champ_1 [0] = $champ_1 [1] = "" ; }
                  $champ_1 [1] = evaluation_champ ($champ_1 [1]) ;
                  Echo "<tr><td>&nbsp;<b>Conditions suppl&eacute;mentaires de s&eacute;lection des champs : (NON OBLIGATOIRE : Peut &ecirc;tre laiss&eacute;s vide)</b>&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;Le&nbsp;champ&nbsp;<select name=\"cs1\"" ; If (IsSet ($cs1) And ($cs1 == 0)) { Echo " selected" ; }
		  Echo "><option value=\"0\">Aucune s&eacute;lection</option>" ;
                  For ($i = 1 ; $i <= $nombre_champs ; $i++)
                   {
                    Echo "<option value=\"".$i."\"" ;
		    If (IsSet ($cs1) And ($cs1 == $i)) { Echo " selected" ; } ElseIf (($entete == 1) And ($le [$i-1] == "Divcod") And ($tt_cl == 0)) { Echo " selected" ; }
                    If ($entete == 1) { Echo ">".$le [$i-1]."</option>" ; } Else { Echo ">num&eacute;ro ".$i."|".$nombre_champs."</option>" ; }
                   }
                  Echo "</select>&nbsp;doit contenir&nbsp;la&nbsp;valeur&nbsp;<input type=\"text\" name=\"ts1\" value=\"" ;
                  If (IsSet ($ts1) And ($ts1 != "")) { Echo $ts1 ; } ElseIf (IsSet ($champ_1 [1])) { Echo $champ_1 [1] ; }
                  Echo "\" size=\"10\" maxlength=\"200\">&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;&nbsp;<b>OU</b>&nbsp;</td></tr>" ;
                  // Condition supplementaire 2
                  If (IsSet ($champ_s [1])) { $
		  $champ_2 = Explode ("->", $champ_s [1]) ; } Else { $champ_2 [0] = $champ_2 [1] = "" ; }
                  $champ_2 [1] = evaluation_champ ($champ_2 [1]) ;
                  Echo "<tr><td>&nbsp;Le&nbsp;champ&nbsp;<select name=\"cs2\"><option value=\"0\"" ; If (IsSet ($cs2) And ($cs2 == 0)) { Echo " selected" ; }
		  Echo ">Aucune s&eacute;lection</option>" ;
                  For ($i = 1 ; $i <= $nombre_champs ; $i++)
                   {
                    Echo "<option value=\"".$i."\"" ;
                    If (IsSet ($cs2) And ($cs2 == $i)) { Echo " selected" ; } ElseIf (($entete == 1) And (IsSet ($champ_2 [0]) And ($champ_2 [0] == $le [$i-1]))) { Echo " selected" ; }
                    If ($entete == 1) { Echo ">".$le [$i-1]."</option>" ; } Else { Echo ">num&eacute;ro ".$i."</option>" ; }
                   }
                  Echo "</select>&nbsp;doit contenir&nbsp;la&nbsp;valeur&nbsp;<input type=\"text\" name=\"ts2\" value=\"" ;
                  If (IsSet ($ts2) And ($ts2 != "")) { Echo $ts2 ; } ElseIf (IsSet ($champ_2 [1])) { Echo $champ_2 [1] ; }
                  Echo "\" size=\"10\" maxlength=\"200\">&nbsp;</td></tr>" ;
                  Echo "<tr><td>&nbsp;</td></tr>" ;
                  Echo "</form>" ;
                  Echo "<tr><td>&nbsp;<a href=\"./importation_notes.php?etape=".($etape-1)."&numero_etape=".($numero_etape-1)."&nombre=".$nombre."&entete=".$entete."&separateur=".$separateur."&delimiteur=".$delimiteur."&id_classe=".$id_classe."&professeur=".$professeur."&discipline=".$discipline."&id_service_prof=".$id_service_prof."&periode=".$periode."&menu=".$menu."\" title=\"Choix de l'&eacute;tape...\">&nbsp;<--PR&Eacute;C&Eacute;DENT&nbsp;</a>&nbsp;</td></tr>" ;
                  Echo "<tr><td align=\"right\"><a href=\"javascript:valide()\" border=\"0\" title=\"&Eacute;tape suivante...\">&nbsp;SUIVANT&nbsp;-->&nbsp;</a></td></tr>" ;
                  Echo "<tr><td>&nbsp;</td></tr>" ;
                 }
                Echo "</table>" ;
		//Echo "</td></tr></table>" ;
		Include ("../include/fin_theme.inc") ;
                Break ;
       // Traitement des donnees et affichage des resultats avant validation
       Case 2 : $entete = var_courante ("entete", 0, 0) ;
                $separateur = var_courante ("separateur", 0, $separateurs [0][1]) ;
                $delimiteur = var_courante ("delimiteur", 0, 1) ;
                $nombre = var_courante ("nombre", 0, 0) ;
                $cond_sup1 = var_courante ("cs1", 0, 0)-1 ;
                $texte_cond_sup1 = var_courante ("ts1", 0, 0) ;
                $texte_cond_sup1 = Str_Replace ("\'", "'", $texte_cond_sup1) ;
                $cond_sup2 = var_courante ("cs2", 0, 0)-1 ;
                $texte_cond_sup2 = var_courante ("ts2", 0, 0) ;
                $texte_cond_sup2 = Str_Replace ("\'", "'", $texte_cond_sup2) ;
                $format_date = var_courante ("format_date", 0, 0) ;
		$nombre_champs = var_courante ("nombre_champs", 0, 0) ;
                
                If ($nombre > 0)
                 {
                  // Analyse de l'association
                  $association = 0 ;
		  $note = 0 ;
		  $comparaison [0][0] = 0 ;
		  $requete_retour = "" ;
		  $ok_rr = 0 ;
                  For ($i = 0 ; $i < $nombre ; $i++)
                   {
                    If ($_POST ["c".$i] != 0)
                     {
                      // Champ a prendre en compte
		      If ((integer)$_POST ["c".$i] == 1)
		       {
		        // Champ contenant la note
			$champ_note = $i ;
			$association++ ;
			If ($ok_rr == 1) { $requete_retour .= "&" ; }
			$requete_retour .= "c".$i."=1" ;
			$ok_rr = 1 ;
		       }
		      ElseIf ($_POST ["c".$i] > 1)
		       {
		        $association++ ;
		        $comparaison [0][0]++ ;
			$comparaison [$comparaison [0][0]][0] = $i ; // Numero du champ
			$comparaison [$comparaison [0][0]][1] = $_POST ["c".$i] ; // Numero du champ reel associe
			If ($ok_rr == 1) { $requete_retour .= "&" ; }
			$requete_retour .= "c".$i."=".$_POST ["c".$i] ;
			$ok_rr = 1 ;
		       }
                     }
                   }
		  
                  If (($association > 1) And ($champ_note != 0))
                   {
		    $entetes = SQL_commande ("SELECT ligne FROM ".$nom_table." WHERE id_imp_texte=".$entete." LIMIT 1", $id_sql) ;
                    $ligne_entetes = SQL_ligne_suivante ($entetes) ;
                    $le = Explode ($separateurs [$separateur][0], $ligne_entetes [0]) ;
                    $resultat = SQL_commande ("SELECT ligne FROM ".$nom_table." WHERE id_imp_texte>".$entete, $id_sql) ;
		    $nombre_lignes = SQL_nbr_lignes ($resultat) ;
                    If ($nombre_lignes > 0)
		     {
		      // Destruction de la table de preparation
                      $ok = SQL_commande ("DROP TABLE ".$nom_table_prepa, $id_sql) ;
                      // Creation de la table de preparation
                      $ok = SQL_commande ("CREATE TABLE ".$nom_table_prepa." (id_imp_prepa INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		                           id_eleve INT(11) UNSIGNED NOT NULL,
					   id_classe INT(11) UNSIGNED NOT NULL,
					   id_service_prof INT(11) UNSIGNED NOT NULL,
					   id_professeur INT(11) UNSIGNED NOT NULL,
					   note TEXT,PRIMARY KEY(id_imp_prepa))", $id_sql) ;
		      $nbr_total_eleves = 0 ;
		      $prepa_eleves [0][0] = 0 ;
		      For ($i = 0 ; $i < $nombre_lignes ; $i++)
		       {
		        $ligne = SQL_ligne_suivante ($resultat) ;
			$ls = Explode ($separateurs [$separateur][0], $ligne [0]) ;
			// Conditions supplementaires avant de rechercher
			$comp = 0 ;
			If ($cond_sup1 > -1)
			 {
			  If ($ok_rr == 1) { $requete_retour .= "&" ; }
			  $requete_retour .= "cs1=".$cond_sup1."&ts1=".$texte_cond_sup1 ;
			  $ok_rr = 1 ;
			  If ($ls [$cond_sup1] == $texte_cond_sup1) { $comp++ ; }
			 } Else { $comp++ ; }
			If ($cond_sup2 > -1)
			 {
			  If ($ok_rr == 1) { $requete_retour .= "&" ; }
			  $requete_retour .= "cs2=".$cond_sup2."&ts2=".$texte_cond_sup2 ;
			  $ok_rr = 1 ;
			  If ($ls [$cond_sup2] == $texte_cond_sup2) { $comp++ ; }
			 } Else { $comp++ ; }
			// Comparaison
			If ($comp == 2)
			 {
			  If (SizeOf ($ls) > $nombre_champs) { $nombre = $nombre_champs ; } Else { $nombre = SizeOf ($ls) ; }
			  // Recherche la note
			  If ($delimiteur > 1)
                           {
		            If ($delimiteur != 2) { $car_delimiteur = SubStr ($delimiteurs [$delimiteur][1], 0, 1) ; } Else { $car_delimiteur = "\"" ; }
                            If (SubStr ($ls [$champ_note], 0, 1) == $car_delimiteur) { $ls [$champ_note] = SubStr ($ls [$champ_note], 1, StrLen ($ls [$champ_note])-1) ; }
                            If (SubStr ($ls [$champ_note], StrLen ($ls [$champ_note])-1, 1) == $car_delimiteur) { $ls [$champ_note] = SubStr ($ls [$champ_note], 0, StrLen ($ls [$champ_note])-1) ; }
                           }
			  $note = $ls [$champ_note] ;
			  
			  $requete = "" ;
			  $ok = $ok_dt = 0 ;
			  For ($j = 1 ; $j <= $comparaison [0][0] ; $j++)
			   {
			    $champ = $ls [$comparaison [$j][0]] ;
			    If ($delimiteur > 1)
                             {
		              If ($delimiteur != 2) { $car_delimiteur = SubStr ($delimiteurs [$delimiteur][1], 0, 1) ; } Else { $car_delimiteur = "\"" ; }
                              If (SubStr ($champ, 0, 1) == $car_delimiteur) { $champ = SubStr ($champ, 1, StrLen ($champ)-1) ; }
                              If (SubStr ($champ, StrLen ($champ)-1, 1) == $car_delimiteur) { $champ = SubStr ($champ, 0, StrLen ($champ)-1) ; }
                             }
			    Switch ($comparaison [$j][1]) 
			     {
			      // Nom
			      Case 2 : If ($ok == 1) { $requete .= " AND " ; }
			               $requete .= "nom='".StrToUpper (filtrage_accents ($champ))."'" ;
				       $ok = 1 ;
			               Break ;
			      // Prenom
			      Case 3 : If ($ok == 1) { $requete .= " AND " ; }
			               $prenoms = $champ ;
				       If (StrPos ($prenoms, " ")) { $prenoms = SubStr ($prenoms, 0, StrPos ($prenoms, " ")) ; }
			               $requete .= "prenoms='".StrToUpper (filtrage_accents ($prenoms))."'" ;
			  	       $ok = 1 ;
			               Break ;
			      // Date naissance
			      Case 4 : Switch ($format_date)
                                        {
                                         Case 1 : $champ_date = SubStr ($champ, 0, 4)."-".SubStr ($champ, 4, 2)."-".SubStr ($champ, 6, 2) ; Break ;
                                         Case 2 : $champ_date = Str_Replace ("/", "-", $champ) ; Break ;
                                         Case 3 : $dt = Explode ("-", $champ) ; $champ_date = $dt [0]."-".$dt [1]."-".$dt [2] ; Break ;
                                         Case 4 : $champ_date = SubStr ($champ, 0, 2)."-".SubStr ($champ, 2, 2)."-".SubStr ($champ, 4, 2) ; Break ;
                                         Case 5 : $dt = Explode ("/", $champ) ; $champ_date = $dt [2]."-".$dt [1]."-".$dt [0] ; Break ;
				         Case 6 : $dt = Explode ("/", $champ) ; $champ_date = $dt [1]."-".$dt [0] ; $ok_dt = 1 ; Break ;
                                        }
				       $ok_dt++ ;
				       If ($ok == 1) { $requete .= " AND " ; }
				       If ($ok_dt == 1) { $requete .= "date_naissance='".$champ_date."'" ; }
				       Else { $requete .= "SUBSTRING(date_naissance,6,5)='".$champ_date."'" ; }
			               Break ;
			      // Divcod
			      Case 5 : If ($ok == 1) { $requete .= " AND " ; }
			               $requete .= "code_classe='".StrToUpper (filtrage_accents ($champ))."'" ;
			  	       $ok = 1 ;
			               Break ;
			     }
			   }
			  // ." AND classe='".$id_classe."'"
			  $resultat_eleve = SQL_commande ("SELECT id_eleve,nom,prenoms,classe FROM eleves WHERE ".$requete, $id_sql) ;
			  $nbr_eleves = SQL_nbr_lignes ($resultat_eleve) ;
			  If ($nbr_eleves == 1)
			   {
			    $lg = SQL_ligne_suivante ($resultat_eleve) ;
			    
			    // Recherche le service prof associe
			    $service_prof = SQL_commande ("SELECT id_service_prof,professeur FROM services_prof WHERE discipline='".$discipline."' AND classe='".$lg [3]."'", $id_sql) ;
			    $nsp = SQL_nbr_lignes ($service_prof) ;
			    If ($nsp == 1)
			     {
			      $sp = SQL_ligne_suivante ($service_prof) ;
			      If ($sp [1] < 0) { $aep = alias_enseignant_principal (-$sp [1]) ; $sp [1] = $aep [0] ; }
			      $nbr_total_eleves++ ;
			      $prepa_eleves [0][0]++ ;
			      $prepa_eleves [$prepa_eleves [0][0]][0] = $lg [0] ; // Id eleve
			      $prepa_eleves [$prepa_eleves [0][0]][1] = $lg [1] ; // Nom
			      $prepa_eleves [$prepa_eleves [0][0]][2] = $lg [2] ; // Prenom
			      $prepa_eleves [$prepa_eleves [0][0]][3] = $note ;   // Note
			      $prepa_eleves [$prepa_eleves [0][0]][4] = $lg [3] ; // Id classe
			      $ok = SQL_commande ("INSERT INTO ".$nom_table_prepa." (id_imp_prepa,id_eleve,id_classe,id_service_prof,id_professeur,note) VALUES ('','".$lg [0]."','".$lg [3]."','".$sp [0]."','".$sp [1]."','".$note."')", $id_sql) ;
			     }
			    Else
			     {
			      // Ambiguite du service donc on ne prend pas
			     }
			   }
			  Else
			   {
			    For ($j = 0 ; $j < $nbr_eleves ; $j++)
		             {
			      $lg = SQL_ligne_suivante ($resultat_eleve) ;
			      echo $lg [0]."->".$lg [1]."->".$lg [2]."<br>" ;
			     }
			   }
			 }
			Else
			 {
			  // Au suivant
			 }
		       }
		     }
		    Else
		     {
		      // Pas de lignes
		     }
		    $titre_fenetre = "&nbsp;<b>Importation&nbsp;.</b>&nbsp;(".$numero_etape."/".$nombre_etapes.")" ;
                    $non_centrer = 0 ;
                    Include ("../include/debut_theme.inc") ;
		    //Echo "<table border=\"1\" bgcolor=\"".$l ["couleur_fond"]."\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\" style=\"border:1px solid #000000;border-collapse:collapse\">" ;
                    //Echo "<tr><td bgcolor=\"".$l ["lien"]."\">&nbsp;<b>Importation&nbsp;.</b>&nbsp;(".$numero_etape."/".$nombre_etapes.")&nbsp;</td></tr>" ;
                    //Echo "<tr><td>" ;
                    Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border-collapse:collapse\">" ;
                    Echo "<tr><td>&nbsp;</td></tr>" ;
		    If ($prepa_eleves [0][0] > 0)
		     {
		      Echo "<tr><td>&nbsp;Pr&eacute;paration&nbsp;&agrave;&nbsp;" ;
		      If ($type_discipline == 0) { Echo "l'insertion" ; } Else { Echo "la&nbsp;mise&nbsp;&agrave;&nbsp;jour" ; }
		      Echo "&nbsp;de" ; If ($nbr_total_eleves > 1) { Echo "s" ; }
		      Echo "&nbsp;".$nbr_total_eleves."&nbsp;enregistrement" ; If ($nbr_total_eleves > 1) { Echo "s" ; }
		      Echo " suivant" ; If ($nbr_total_eleves > 1) { Echo "s" ; }
		      Echo ".&nbsp;</td></tr>" ;
		      Echo "<tr><td>&nbsp;</td></tr>" ;
		      Echo "<tr><td><table border=\"1\" bgcolor=\"".$l ["couleur_fond"]."\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\" style=\"border:1px solid #000000;border-collapse:collapse\">" ;
                      Echo "<tr bgcolor=\"".$l ["lien"]."\"><td>&nbsp;<b>&Eacute;l&egrave;ve</b>&nbsp;</td><td align=\"center\">&nbsp;<b>Note</b>&nbsp;</td></tr>" ;
		      $classe = $prepa_eleves [1][4] ;
		      $compteur = 0 ;
		      If ($tt_cl == 1) { Echo "<tr><td bgcolor=\"".$l ["lien"]."\" colspan=\"2\">&nbsp;<b><i>".nom_classe_long_parid ($classe)."</i></b>&nbsp;</td></tr>" ; }
		      For ($i = 1 ; $i <= $prepa_eleves [0][0] ; $i++)
		       {
		        If ($prepa_eleves [$i][4] != $classe) 
			 {
			  Echo "<tr><td bgcolor=\"".$l ["lien"]."\" colspan=\"2\" align=\"right\">Soit&nbsp;".$compteur."&nbsp;&eacute;l&egrave;ve" ; If ($compteur > 1) { Echo "s" ; }
			  Echo "&nbsp;</td></tr>" ;
			  $classe = $prepa_eleves [$i][4] ;
			  Echo "<tr><td bgcolor=\"".$l ["lien"]."\" colspan=\"2\">&nbsp;<b><i>".nom_classe_long_parid ($classe)."</i></b>&nbsp;</td></tr>" ;
			  $compteur = 0 ;
			 }
			$compteur++ ;
		        Echo "<tr" ; If ($i%2 == 0) { Echo " bgcolor=\"".$l ["nom"]."\"" ; }
			Echo "><td>&nbsp;<b>".$prepa_eleves [$i][1]."</b>&nbsp;<i>".$prepa_eleves [$i][2]."</i>&nbsp;</td>" ;
			Echo "<td align=\"center\">&nbsp;".$prepa_eleves [$i][3] ; If ($type_discipline == 3) { Echo "%" ; }
			Echo "&nbsp;</td></tr>" ;
		       }
		      Echo "</table></td></tr>" ;
		      $maj = 1 ;
		     }
		    Else
		     {
		      Echo "<tr><td align=\"center\">&nbsp;Aucune&nbsp;ligne&nbsp;du&nbsp;fichier&nbsp;ne&nbsp;r&eacute;pond&nbsp;aux&nbsp;crit&egrave;res&nbsp;de&nbsp;s&eacute;lection.</td></tr>" ;
		     }
                   }
                  Else
                   {
                    // Pas d'association ou il en manque
		    If ($association == 0) { Echo "<tr><td align=\"center\">&nbsp;Aucune&nbsp;association&nbsp;n'a&nbsp;&eacute;t&eacute;&nbsp;d&eacute;fini.&nbsp;</td></tr>" ; }
		    ElseIf (($association > 1) And ($note == 0)) { Echo "<tr><td align=\"center\">&nbsp;Il&nbsp;manque&nbsp;l'association&nbsp;du&nbsp;champ&nbsp;\"<i>Note</i>\".&nbsp;</td></tr>" ; }
		    Else { Echo "<tr><td align=\"center\">&nbsp;Il&nbsp;manque&nbsp;des&nbsp;associations&nbsp;.</td></tr>" ; }
		    $maj = 0 ;
                   }
                 }
                Else
                 {
                  // Probleme : Pas de champs !
                  Echo "<tr><td>&nbsp;ATTENTION&nbsp;:&nbsp;Aucun&nbsp;champ&nbsp;n'a&nbsp;&eacute;t&eacute;&nbsp;d&eacute;fini.&nbsp;</td></tr>" ;
		  $maj = 0 ;
                 }
		Echo "<tr><td>&nbsp;</td></tr>" ;
		If ($maj == 0)
		 {
		  Echo "<tr><td align=\"right\"><a href=\"./importation_notes.php?etape=".($etape+2)."&numero_etape=".($numero_etape+2)."&maj=0&id_classe=".$id_classe."&professeur=".$professeur."&discipline=".$discipline."&id_service_prof=".$id_service_prof."&periode=".$periode."&menu=".$menu."&tt_cl=".$tt_cl."\" border=\"0\" title=\"Fin de l'importation...\">&nbsp;TERMIN&Eacute;&nbsp;-->&nbsp;</a></td></tr>" ;
		 }
                Else
		 {
		  Echo "<tr><td align=\"right\"><a href=\"./importation_notes.php?etape=".($etape+1)."&numero_etape=".($numero_etape+1)."&maj=".$maj."&id_classe=".$id_classe."&professeur=".$professeur."&discipline=".$discipline."&id_service_prof=".$id_service_prof."&periode=".$periode."&menu=".$menu."&tt_cl=".$tt_cl."\" border=\"0\" title=\"Valider l'importation...\">&nbsp;VALIDER&nbsp;l'IMPORTATION&nbsp;-->&nbsp;</a></td></tr>" ;
		 }
		Echo "<tr><td>&nbsp;</td></tr>" ;
		Echo "<tr><td><a href=\"./importation_notes.php?tel=1&etape=".($etape-1)."&numero_etape=".($numero_etape-1)."&entete=".$entete."&nombre=".$nombre."&nombre_champs=".$nombre_champs."&id_classe=".$id_classe."&professeur=".$professeur."&discipline=".$discipline."&id_service_prof=".$id_service_prof."&periode=".$periode."&menu=".$menu."&tt_cl=".$tt_cl."&format_date=".$format_date."&".$requete_retour."\" border=\"0\" title=\"Revenir &agrave; l'&eacute;tape pr&eacute;c&eacute;dente...\">&nbsp;<--Pr&eacute;c&eacute;dent&nbsp;</a></td></tr>" ;
                Echo "<tr><td>&nbsp;</td></tr>" ;
                Echo "</table>" ;
		//Echo "</td></tr></table>" ;
		Include ("../include/debut_theme.inc") ;
                Break ;
       // Validation des resultats
       Case 3 :	$maj = var_courante ("maj", 0, 0) ;
       
                If ($maj == 1)
		 {
		  // Mise a jour
		  // Recherche de toutes les mises a jour
		  $resultats = SQL_commande ("SELECT id_eleve,id_classe,id_service_prof,id_professeur,note FROM ".$nom_table_prepa, $id_sql) ;
		  $nbr_r = SQL_nbr_lignes ($resultats) ;
		  For ($i = 0 ; $i < $nbr_r ; $i++)
		   {
		    $ligne = SQL_ligne_suivante ($resultats) ;
		    // Recherche identifiant unique pour la classe
                    $resultat = SQL_commande ("SELECT nom_bref FROM classes WHERE id_classe='".$ligne [1]."' LIMIT 1", $id_sql) ;
                    $lg = SQL_ligne_suivante ($resultat) ;
                    $code_c = $lg [0] ;
                    // Recherche identifiant unique pour le professeur
                    $resultat = SQL_commande ("SELECT numen FROM utilisateurs WHERE id_utilisateur='".$ligne [3]."' LIMIT 1", $id_sql) ;
                    $lg = SQL_ligne_suivante ($resultat) ;
                    $code_p = $lg [0] ;
                    // Recherche identifiant unique pour la discipline
                    $resultat = SQL_commande ("SELECT code FROM disciplines WHERE id_discipline='".$discipline."' LIMIT 1", $id_sql) ;
                    $lg = SQL_ligne_suivante ($resultat) ;
                    $code_d = $lg [0] ;
		    // Recherche du controle
		    $nbr_ct = 0 ;
		    If ($type_discipline == 3)
		     {
		      $ct = SQL_commande ("SELECT id_controle FROM controles WHERE classe='".$ligne [1]."' AND professeur='".$ligne [3]."' AND discipline='".$discipline."' AND service_prof='".$ligne [2]."' AND periode='".$periode."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
		      $nbr_ct = SQL_nbr_lignes ($ct) ;
		      If ($nbr_ct == 1) 
		       {
		        $ctrl = SQL_ligne_suivante ($ct) ;
                        $controle = $ctrl [0] ;
		       }
		     }
		    // Ajout du controle
		    If (($type_discipline == 0) Or (($type_discipline == 3) And ($nbr_ct == 0)))
		     {
		      // Enregistrement du controle
                      // Recherche de la session courante
                      //$resultat = SQL_commande ("SELECT * FROM sessions WHERE id_session='".$_SESSION ["code"]."' LIMIT 1", $id_sql) ;
                      //$param = SQL_tableau_associatif ($resultat, "") ;
                      //$note_max = $param ["max"] ;
                      If ($note_max <= 0)
                       {
		        If ($type_moyenne == 0)
			 {
                          If ($note_par_defaut <= 0) { $note_max = $gestion ["max"] ; }
                          Else { $note_max = $note_par_defaut ; }
			 }
			Else { $note_max = 100 ; }
                       }
                      $sous_mat = 0 ;
                      If ($sous_mat < 1) { $sous_mat = 0 ; }
		      $coefficient = 1 ;
		      $examen = 0 ;
                      
                      $dh = Date ("Y-m-j H:i:s") ;
		      $dd = Date ("Y-m-j") ;
                      $ct = SQL_commande ("INSERT INTO controles (date,classe,code_classe,professeur,numen,discipline,code_disc,service_prof,description,coefficient,periode,enregistrement,examen,max,id,sous_matiere,millesime)
                                           VALUES ('".$dd."','".$ligne [1]."','".$code_c."','".$ligne [3]."','".$code_p."','".$discipline."','".$code_d."','".$ligne [2]."','','".$coefficient."','".$periode."','".$dh."','".$examen."','".$note_max."','".Session_Id()."','".$sous_mat."','".$millesime."')", $id_sql) ;
                      $cnntrnle = SQL_commande ("SELECT id_controle,coefficient AS a FROM controles
                                                  WHERE date='".$dd."' AND classe='".$ligne [1]."'
             				            AND code_classe='".$code_c."' AND professeur='".$ligne [3]."'
             				            AND numen='".$code_p."' AND discipline='".$discipline."'
             				            AND code_disc='".$code_d."' AND service_prof='".$ligne [2]."'
             				            AND description='' AND periode='".$periode."'
             				            AND enregistrement='".$dh."' AND examen='0'
             				            AND max='".$note_max."' AND id='".Session_Id()."' AND millesime='".$millesime."'
             				            AND sous_matiere='".$sous_mat."' HAVING ABS(a-".$coefficient.")<0.001
                                                  LIMIT 1", $id_sql) ;
                      If (SQL_nbr_lignes ($cnntrnle) == 1)
                       {
                        $ctrl = SQL_ligne_suivante ($cnntrnle) ;
                        $controle = $ctrl [0] ;
                       }
                      Else
                       {
                        $cnntrnle = SQL_commande ("SELECT MAX(id_controle) FROM controles WHERE millesime='".$millesime."'", $id_sql) ;
		        $ctrl = SQL_ligne_suivante ($cnntrnle) ;
                        $controle = $ctrl [0] ;
                       }
                     }
		    ElseIf (($type_discipline == 3) And ($nbr_ct != 0))
		     {
		      // Mise a jour controle
		      If ($note_max <= 0)
                       {
		        If ($type_moyenne == 0)
			 {
                          If ($note_par_defaut <= 0) { $note_max = $gestion ["max"] ; }
                          Else { $note_max = $note_par_defaut ; }
			 }
			Else { $note_max = 100 ; }
                       }
		      $dmaj = Date ("Y-m-j H:i:s") ;
		      $ct = SQL_commande ("UPDATE controles SET date_maj='".$dmaj."',max='".$note_max."' WHERE id_controle='".$controle."' LIMIT 1", $id_sql) ;
		     }
		    // Ajout des notes
		    If (($type_discipline == 0) Or (($type_discipline == 3) And ($nbr_ct == 0)))
		     {
                      // Enregistrement des notes
		      $eleve = SQL_commande ("SELECT repere1,repere2 FROM eleves WHERE id_eleve='".$ligne [0]."' LIMIT 1", $id_sql) ;
		      $el = SQL_ligne_suivante ($eleve) ;
		      $requete = "INSERT INTO notes (eleve,repere1,repere2,valeur,controle,id,enregistrement,millesime) VALUES " ;
		      $requete .= "('".$ligne [0]."','".$el [0]."','".$el [1]."','".$ligne [4]."','".$controle."','".Session_Id ()."','".$dh."','".$millesime."')" ;
		      $ok = SQL_commande ($requete, $id_sql) ;
		     }
		    ElseIf (($type_discipline == 3) And ($nbr_ct == 1))
		     {
		      // Mise a jour des notes
		      $note = SQL_commande ("SELECT id_note FROM notes WHERE eleve='".$ligne [0]."' AND controle='".$controle."' LIMIT 1", $id_sql) ;
		      If (SQL_nbr_lignes ($note) == 1)
		       {
		        // Existe -> mise a jour
		        $nt = SQL_ligne_suivante ($note) ;
		        $ok = SQL_commande ("UPDATE notes SET valeur='".$ligne [4]."' WHERE id_note='".$nt [0]."' LIMIT 1", $id_sql) ;
		       }
		      Else
		       {
		        // N'existe pas -> creation
		        $eleve = SQL_commande ("SELECT repere1,repere2 FROM eleves WHERE id_eleve='".$ligne [0]."' LIMIT 1", $id_sql) ;
		        $el = SQL_ligne_suivante ($eleve) ;
		        $requete = "INSERT INTO notes (eleve,repere1,repere2,valeur,controle,id,enregistrement,millesime) VALUES " ;
		        $requete .= "('".$ligne [0]."','".$el [0]."','".$el [1]."','".$ligne [4]."','".$controle."','".Session_Id ()."','".$dh."','".$millesime."')" ;
		        $ok = SQL_commande ($requete, $id_sql) ;
		       }
		     }
		   }
		  $titre_fenetre = "&nbsp;<b>Importation&nbsp;.</b>&nbsp;(".$numero_etape."/".$nombre_etapes.")" ;
                  $non_centrer = 0 ;
                  Include ("../include/debut_theme.inc") ;
		  //Echo "<table border=\"1\" bgcolor=\"".$l ["couleur_fond"]."\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\" style=\"border:1px solid #000000;border-collapse:collapse\">" ;
                  //Echo "<tr><td bgcolor=\"".$l ["lien"]."\">&nbsp;<b>Importation&nbsp;.</b>&nbsp;(".$numero_etape."/".$nombre_etapes.")&nbsp;</td></tr>" ;
                  //Echo "<tr><td>" ;
                  Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border-collapse:collapse\">" ;
                  Echo "<tr><td>&nbsp;</td></tr>" ;
		  Echo "<tr><td align=\"center\">&nbsp;Importation&nbsp;termin&eacute;e.&nbsp;</td></tr>" ;
		  Echo "<tr><td>&nbsp;</td></tr>" ;
		  Echo "<tr><td align=\"right\"><a href=\"./importation_notes.php?etape=".($etape+1)."&numero_etape=".($numero_etape+1)."&maj=0&id_classe=".$id_classe."&professeur=".$professeur."&discipline=".$discipline."&id_service_prof=".$id_service_prof."&periode=".$periode."&menu=".$menu."\" border=\"0\" title=\"Fin de l'importation...\">&nbsp;TERMIN&Eacute;&nbsp;-->&nbsp;</a></td></tr>" ;
		  Echo "<tr><td>&nbsp;</td></tr>" ;
		  Echo "</table>" ;
		  //Echo "</td></tr></table>" ;
		  Include ("../include/debut_theme.inc") ;
		 }
		ElseIf ($maj == 0)
		 {
		  Echo "<script type=\"text/javascript\">window.open(\"./saisie_notes.php?code=".$_SESSION ["code"]."&id_classe=".$id_classe."&professeur=".$professeur."&id_service_prof=".$id_service_prof."&periode=".$periode ;
	          If ($droit_courant != $droit_prof) { Echo "&menu=200\",\"travail_affichage_3" ; } Else { Echo "\",\"travail_affichage" ; }
	          Echo "\",\"\");window.close();</script>" ;
		 }
                Break ;
       // Sortie de l'interface
       Case 4 :	$ok = SQL_commande ("DELETE FROM ".$nom_table." WHERE ligne LIKE '".Session_Id ().$separateurs [$separateur][0]."%'", $id_sql) ;
                $maj = var_courante ("maj", 0, 0) ;
                Echo "<script type=\"text/javascript\">" ;
                If ($maj == 0)
		 {
		  Echo "window.open(\"./saisie_notes.php?code=".$_SESSION ["code"]."&id_classe=".$id_classe."&professeur=".$professeur."&id_service_prof=".$id_service_prof."&periode=".$periode ;
	          If ($droit_courant != $droit_prof) { Echo "&menu=200\",\"travail_affichage_3" ; } Else { Echo "\",\"travail_affichage" ; }
	          Echo "\",\"\");" ;
		 }
		Echo "window.close();</script>" ;
                Break ;
      }
    }
   Else
    {
     // Probleme
     Echo "<br><br><center>Il y a un probl&egrave;me d'acc&egrave;s &agrave; cette interface !<br>Recommencez SVP !</center>" ;
    }
  }
 Else
  {
   $separateur = var_courante ("separateur", 0, $separateurs [0][1]) ;
   $delimiteur = var_courante ("delimiteur", 0, 1) ;
   // PREMIERE PAGE
   Echo "<script type=\"text/javascript\">function valide(){if(document.insertion.fichier.value==''){alert(\"Vous n'avez pas selectionne le fichier TEXTE au format CSV.\");return false;}else{return true;}}</script>" ;
   $titre_fenetre = "&nbsp;Interface&nbsp;d'importation&nbsp;de&nbsp;notes&nbsp;au&nbsp;format&nbsp;CSV.&nbsp;&Eacute;tape&nbsp;1." ;
   $non_centrer = 0 ;
   Include ("../include/debut_theme.inc") ;
   Echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" style=\"border-collapse:collapse\">" ;
   Echo "<tr><td colspan=\"2\">&nbsp;<b>Avertissement</b>&nbsp;:&nbsp;<br>&nbsp;</td></tr>" ;
   Echo "<tr><td colspan=\"2\">&nbsp;Cette interface permet d'importer une s&eacute;rie de notes &agrave; partir d'un fichier au format CSV, comme, par exemple, un enregistrement CSV d'OpenOffice Calc.&nbsp;</td></tr>" ;
   If ($type_discipline == 0)
    {
     Echo "<tr><td colspan=\"2\">&nbsp;Votre discipline &eacute;tant \"<i>normale</i>\", vous aurez une ou plusieurs colonne(s) de notes suppl&eacute;mentaire(s).&nbsp;</td></tr>" ;
    }
   ElseIf ($type_discipline == 3)
    {
     Echo "<tr><td colspan=\"2\">&nbsp;Apr&egrave;s importation, la discipline &eacute;tant \"<i>sp&eacute;cifique</i>\", toute la colonne de notes pr&eacute;sente sera remplac&eacute;e par cette s&eacute;rie.&nbsp;</td></tr>" ;
    }
   Echo "<tr><td colspan=\"2\"><br>&nbsp;Vous avez la possiblit&eacute; d'avoir jusqu'&agrave; 4 <b>lignes</b> d'ent&ecirc;tes : <b>Date</b>, <b>Coefficient</b>, <b>Not&eacute; sur</b> et <b>Sous-mati&egrave;re</b>...&nbsp;</td></tr>" ;
   Echo "<tr><td colspan=\"2\">&nbsp;</td></tr>" ;
   Echo "<form action=\"./importation_notes.php\" name=\"insertion\" method=\"post\" enctype=\"multipart/form-data\" onSubmit=\"return valide()\">" ;
   Echo "<input type=\"hidden\" name=\"etape\" value=\"1\">" ;
   Echo "<input type=\"hidden\" name=\"numero_etape\" value=\"2\">" ;
   Echo "<input type=\"hidden\" name=\"id_classe\" value=\"".$id_classe."\">" ;
   Echo "<input type=\"hidden\" name=\"professeur\" value=\"".$professeur."\">" ;
   Echo "<input type=\"hidden\" name=\"discipline\" value=\"".$discipline."\">" ;
   Echo "<input type=\"hidden\" name=\"id_service_prof\" value=\"".$id_service_prof."\">" ;
   Echo "<input type=\"hidden\" name=\"periode\" value=\"".$periode."\">" ;
   Echo "<input type=\"hidden\" name=\"menu\" value=\"".$menu."\">" ;
   Echo "<tr><td colspan=\"2\">&nbsp;</td></tr>" ;
   Echo "<tr><td align=\"right\">&nbsp;Indiquer&nbsp;le&nbsp;fichier&nbsp;au&nbsp;format&nbsp;TEXTE&nbsp;CSV&nbsp;:&nbsp;</td>" ;
   Echo "<td><input type=\"file\" name=\"fichier\" size=\"40\">&nbsp;</td></tr>" ;
   Echo "<tr><td colspan=\"2\">&nbsp;</td></tr>" ;
   Echo "<tr><td align=\"right\">&nbsp;<input type=\"checkbox\" name=\"entete\" value=\"1\"" ; If ($entete == 1) { Echo " checked" ; }
   Echo "></td>" ;
   Echo "<td>&nbsp;Cochez&nbsp;cette&nbsp;case,&nbsp;si&nbsp;vous&nbsp;utilisez&nbsp;une&nbsp;ou&nbsp;plusieurs&nbsp;lignes&nbsp;d'ent&ecirc;tes.&nbsp;</td></tr>" ;
   Echo "<tr><td colspan=\"2\">&nbsp;</td></tr>" ;
   Echo "<tr><td colspan=\"2\"><table border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse:collapse\"><tr><td>" ;
   Echo "<fieldset style=\"padding-top:8px;padding-bottom:8px;margin-left:auto;margin-right:auto;-moz-border-radius-topleft:10px;-moz-border-radius-topright:10px;-moz-border-radius-bottomleft:10px;-moz-border-radius-bottomright:10px;\">" ;
   Echo "<legend>&nbsp;<b>Options&nbsp;d'importation&nbsp;:</b>&nbsp;</legend><table border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse:collapse\">" ;
   Echo "<tr bgcolor=\"".$theme [0][45]."\"><td align=\"right\">&nbsp;Type&nbsp;de&nbsp;format&nbsp;:&nbsp;</td>" ;
   Echo "<td><select name=\"type_format\"><option value=\"0\" onclick=\"javascript:active_options()\">Libre</option>" ;
   $format_csv_defaut = 1 ;
   For ($i = 1 ; $i <= $formats_csv [0][0] ; $i++)
    {
     Echo "<option value=\"".$i."\"" ; If ($i == $format_csv_defaut) { Echo " selected" ; }
     Echo " onclick=\"javascript:selection_options(".$formats_csv [$i][1].",".$formats_csv [$i][2].",".($formats_csv [$i][3]-1).")\">".$formats_csv [$i][0]."</option>" ;
    }
   Echo "<tr><td colspan=\"2\">&nbsp;</td></tr>" ;
   Echo "<tr><td align=\"right\">&nbsp;S&eacute;parateur&nbsp;de&nbsp;champs&nbsp;:&nbsp;</td>" ;
   Echo "<td><select name=\"separateur\" id=\"separateur\" disabled>" ;
   For ($i = 1 ; $i <= $separateurs [0][0] ; $i++)
    {
     Echo "<option value=\"".$i."\"" ; If ($i == $formats_csv [$format_csv_defaut][1]) { Echo " selected" ; }
     Echo ">".$separateurs [$i][0]."&nbsp;(".$separateurs [$i][1].")</option>" ;
    }
   Echo "</select>&nbsp;</td></tr>" ;
   Echo "<tr><td align=\"right\">&nbsp;D&eacute;limiteur&nbsp;des&nbsp;champs&nbsp;texte&nbsp;:&nbsp;</td>" ;
   Echo "<td><select name=\"delimiteur\" id=\"delimiteur\" disabled>" ;
   For ($i = 1 ; $i <= $delimiteurs [0] ; $i++)
    {
     Echo "<option value=\"".$i."\"" ; If ($i == $formats_csv [$format_csv_defaut][2]) { Echo " selected" ; }
     Echo ">".$delimiteurs [$i]."</option>" ;
    }
   Echo "</select>&nbsp;</td></tr>" ;
   Echo "<td align=\"right\">&nbsp;Format&nbsp;de&nbsp;la&nbsp;date&nbsp;:&nbsp;</td>" ;
   Echo "<td><select name=\"format_date\" id=\"format_date\" disabled>" ;
   For ($i = 1 ; $i <= $formats_date [0] ; $i++)
    {
     Echo "<option value=\"".($i-1)."\"" ; If ($i == $formats_csv [$format_csv_defaut][3]) { Echo " selected" ; }
     Echo ">".$formats_date [$i]."</option>" ;
    }
   Echo "</select></td></tr>" ;
   Echo "</table></fieldset></td></tr></table></td></tr>" ;
   Echo "<tr><td colspan=\"2\" align=\"right\"><input type=\"image\" name=\"submit\" src=\"../images/valider.png\" value=\"&Eacute;tape suivante...\"></td></tr>" ;
   Echo "</form>" ;
   Echo "<tr><td colspan=\"2\">&nbsp;</td></tr>" ; 
   Echo "</table>" ;
   Include ("../include/fin_theme.inc") ;
  }
 Echo "</body></html>" ;
?>