<?php
 Include ("../../include/var_temp.inc") ;
 $millesime = var_courante ("millesime", 0, Date ("Y")) ;
 @Set_Time_Limit (0) ;
 /*
 * Fonction de creation de la table a traiter temporaire
 * @param string $fichier Nom du fichier temporaire
 * @param string $nom Nom du fichier definitif -> Nom de la table
 */
 Function creation_table ($fichier, $nom)
  {
   Global $table, $aff, $id_sql, $sql_imp, $sql_base ;
   
   $caracteres_1 = Chr(128).Chr(129).Chr(130).Chr(131).Chr(132).Chr(133).Chr(134).Chr(135).Chr(136).Chr(137).Chr(138).Chr(139).Chr(140).Chr(141).Chr(142).Chr(143).Chr(144).Chr(145).Chr(146).Chr(147).Chr(148).Chr(149).Chr(150).Chr(151) ;
   $caracteres_2 = "" ;
   $caracteres_3 = "CueaaaaceeeiiiAAEooouu" ;
   
   $nom = StrToUpper ($nom) ;
   $table [0] = $table [0] + 1 ;
   $table [$table [0]] = $nom ;
   
   $f = FOpen ($fichier, "r") ;
   $ligne = FRead ($f, 32) ;
   $pos_donnees = Ord (SubStr ($ligne, 8, 1))+Ord (SubStr ($ligne, 9, 1))*256 ;
   $nbr_champs = ($pos_donnees - 34) / 32 ;
   $nbr_donnees = Ord (SubStr ($ligne, 7, 1))*16777216+Ord (SubStr ($ligne, 6, 1))*65536+Ord (SubStr ($ligne, 5, 1))*256+Ord (SubStr ($ligne, 4, 1)) ;
   $c = 0 ;
   $taille = 0 ;
   $requete = "CREATE TABLE ".$nom." (id INT AUTO_INCREMENT PRIMARY KEY" ;
   For ($i = 0 ; $i < $nbr_champs ; $i++)
    {
     $ligne = FRead ($f, 32) ;
     $requete .= "," ;
     $nom_champs = Explode (Chr (0), $ligne) ;
     $nbr = Ord (SubStr ($ligne, 16, 1)) ;
     $requete .= $nom_champs [0]." VARCHAR(".$nbr.") NOT NULL" ;
     $taille_champs [$c] = $nbr ;
     $taille += $nbr ;
     $c++ ;
    }
   $taille++ ;
   $requete .= ")" ;
   $ok = SQL_commande ($requete, $id_sql) ;

   $ligne = FRead ($f, 3) ;
   $compteur = 0 ;
   For ($k = 0 ; $k < $nbr_donnees ; $k++)
    {
     $ok = 0 ;
     $debut = 0 ;
     $ligne = FRead ($f, $taille) ;
     $compteur++ ;
     $requete = "INSERT INTO ".$nom." VALUES (''" ;
     For ($i = 0 ; $i < $c ; $i++)
      {
       $fin = $taille_champs [$i] ;
       $chaine = SubStr ($ligne, $debut, $fin) ;
       $chaine = Str_Replace ("'", "\'", $chaine) ;
       For ($j = 0 ; $j < StrLen ($caracteres_1) ; $j++)
        {
	 $chaine = Str_Replace (SubStr ($caracteres_1, $j, 1), SubStr ($caracteres_2, $j, 1), $chaine) ;
	}
       $requete .= ",'".$chaine."'" ;
       If ($chaine) { $ok = 1 ; }
       $debut += $taille_champs [$i] ;
      }
     $requete .= ")" ;
     If ($ok) { $ok = SQL_commande ($requete, $id_sql) ; }
    }
   $ok = FClose ($f) ;
  }
 
 // Creation des tables GEP temporaires
 $table [0] = 0 ;
 UnSet ($message) ;
 For ($cc = 1 ; $cc <= $imp_gep [0] ; $cc++)
  {
   If ($imp_gep [$cc])
    {
     If ((integer)$_FILES ["nom_".$cc]["error"] == 0)
      {
       If (Is_UpLoaded_File ($_FILES ["nom_".$cc]["tmp_name"]))
        {
         If (PHP_OS == "Linux")
          {
	   $nom_temp = Str_Replace (" ","_",$_FILES ["nom_".$cc]["tmp_name"]) ;
           $nom_fichier = Str_Replace (" ","_",$_FILES ["nom_".$cc]["name"]) ;
          }
         Else
          {
           $nom_temp = $_FILES ["nom_".$cc]["tmp_name"] ;
           $nom_fichier = $_FILES ["nom_".$cc]["name"] ;
          }
         //@Copy ("../../tmp/".$nom_fichier, $nom_temp) ;
         creation_table ($nom_temp, SubStr ($nom_fichier, 0, StrPos ($nom_fichier, "."))) ;
	}
       Else
        {
	 $message = "Le fichier ".$imp_gep [$cc]." semble vide : t&eacute;l&eacute;chargement impossible." ;
	}
      }	
     Else
      {
       Switch ((integer)$_FILES ["nom_".$cc]["error"])
        {
          Case 1 : $message  = "Le param&egrave;tre <i>upload_max_filesize</i> dans <b>php.ini</b> est trop petit.<br>" ;
	           $message .= "Vous devez au moins le positionner &agrave; la taille du plus gros fichier que vous avez &agrave; importer." ;
		   Break ;
          Case 2 : $message = "Le param&egrave;tre du formulaire HTML pr&eacute;c&eacute;dent <i>MAX_FILE_SIZE</i> est trop petit." ; Break ;
          Case 3 : $message = "Le transfert du fichier ".$_FILES ["nom_".$cc]["name"]." ne s'est pas effectu&eacute; dans sa totalit&eacute;." ; Break ;
          Case 4 : $message = "Aucun transfert de fichier ne s'est effectu&eacute;." ; Break ;
         Default : $message = "Erreur lors du t&eacute;l&eacute;chargement du fichier ".$_FILES ["nom_".$cc]["name"]." : Corrompu ??" ; Break ;
        }
      }
    }
  }
 If (!IsSet ($message))
  {
   // Variables d'etat
   $ok_etab = 0 ;
   $ok_reg = 0 ;
   $ok_classe = 0 ;
   $ok_disc = 0 ;
   $ok_eleve = 0 ;
 
   // Remplissage de la table etablissements $table [14]
   $r0 = SQL_commande ("SELECT * FROM F_UAA LIMIT 1", $id_sql) ;
   If (SQL_nbr_lignes ($r0) > 0)
    {
     $l0 = SQL_tableau_associatif ($r0, "") ;
     $resultat = SQL_commande ("INSERT INTO etablissements
                                 (nom,adresse,cp,ville,telephone,fax,numero,mel,academie,cahier_textes,debut_cahier_textes,fin_cahier_textes,
			          heure_debut,heure_fin,heure_pas,cahier_public,visu_devoirs,taille_fichier,taille_espace,rep_stockage,
			          moyenne,nombre_chiffres,max,aff_evolution,seuil_bas,seuil_haut,
			          aff_nombre_notes,entete_bulletins,imprimer_logo_bulletins,logo_bulletins,entete_releves,imprimer_logo_releves,
				  logo_releves,coefficient,examen_blanc,aff_nc,aff_c,bulletin_cpe,signature)
                                VALUES
    		                 ('".$l0 ["UAADNP"]." ".$l0 ["UAADNC"]."','".$l0 ["UAAADR"]."','".$l0 ["UAACPL"]."','".$l0 ["UAALDS"]."','".$l0 ["UAATEL"]."',
			          '','".$l0 ["UAARNE"]."','','".$l0 ["UAALACA"]."',1,'','','08:00:00','17:30:00','30',0,0,'100','5000','documents/',
				  0,1,'".$note_par_defaut."',1,'0.5','0.5',0,0,0,'logo_bulletin',0,0,
				  'logo_releve',1,1,0,0,0,1)", $id_sql) ;
     $resultat = SQL_commande ("SELECT id_etablissement FROM etablissements WHERE numero='".$l0 ["UAARNE"]."' LIMIT 1", $id_sql) ;
     $ligne = SQL_ligne_suivante ($resultat) ;
     $ok_etab = 1 ;
    }
   Else
    {
     $resultat = SQL_commande ("INSERT INTO etablissements
                                 (nom,adresse,cp,ville,telephone,fax,numero,mel,academie,cahier_textes,debut_cahier_textes,fin_cahier_textes,
			          heure_debut,heure_fin,heure_pas,cahier_public,visu_devoirs,taille_fichier,taille_espace,rep_stockage,
			          moyenne,nombre_chiffres,max,aff_evolution,seuil_bas,seuil_haut,
			          aff_nombre_notes,entete_bulletins,imprimer_logo_bulletins,logo_bulletins,entete_releves,imprimer_logo_releves,
				  logo_releves,coefficient,examen_blanc,aff_nc,aff_c,bulletin_cpe,signature)
			        VALUES
			         ('','','','','','','00000000','','',1,'','','08:00:00','17:30:00','30',0,0,'100','5000','documents/',
			          1,1,'".$note_par_defaut."',1,'0.5','0.5',0,0,0,'logo_bulletin',0,0,
				  'logo_releve',1,1,0,0,0,1)", $id_sql) ;
     $resultat = SQL_commande ("SELECT id_etablissement FROM etablissements WHERE numero='00000000' LIMIT 1", $id_sql) ;
     $ligne = SQL_ligne_suivante ($resultat) ;
    }
   $numero = $ligne [0] ;

   // Recherche des codes regimes et insertion $table [13]
   $resultat = SQL_commande ("SELECT * FROM N_BEEB1", $id_sql) ;
   If (SQL_nbr_lignes ($resultat) > 0)
    {
     For ($i = 0 ; $i < SQL_nbr_lignes ($resultat) ; $i++)
      {
       $ligne = SQL_ligne_suivante ($resultat) ;
       $r = SQL_commande ("SELECT * FROM types_regimes WHERE code='".$ligne [1]."' LIMIT 1", $id_sql) ;
       If (SQL_nbr_lignes ($r) == 0)
        {
         $ok = SQL_commande ("INSERT INTO types_regimes (code,nom_court,nom_long,millesime) VALUES ('".$ligne [1]."','".Str_Replace ("'", "\'", $ligne [2])."','".Str_Replace ("'", "\'", $ligne [3])."','".$millesime."')", $id_sql) ;
        }
      }
     $ok_reg = 1 ;
    }
   Else
    {
     $ok = SQL_commande ("INSERT INTO types_regimes (code,nom_court,nom_long,millesime)
                          VALUES (0, 'EXT', 'EXTERNE LIBRE','".$millesime."'),
		                 (1, 'EXT SUR', 'EXTERNE SURVEILLE','".$millesime."'),
		                 (2, 'DP DAN', 'DEMI-PENSIONNAIRE DANS L`ETABLISSEMENT','".$millesime."'),
			         (3, 'INT', 'INTERNE','".$millesime."'),
			         (4, 'IN EXT', 'INTERNE EXTERNE','".$millesime."'),
			         (5, 'IN HEB', 'INTERNE HEBERGE','".$millesime."'),
			         (6, 'DP HOR', 'DEMI-PENSIONNAIRE HORS L`ETABLISSEMENT','".$millesime."')", $id_sql) ;
    }
 
   // Recherche des classes et profs principaux et insertion $table [1]
   $resultat = SQL_commande ("SELECT DIVCOD, DIVLIB FROM F_DIV WHERE NUMIND!='' ORDER BY DIVLIB,DIVCOD", $id_sql) ;
   If (SQL_nbr_lignes ($resultat) > 0)
    {
     // Insertion des classes avec profs principaux renseignes
     For ($i = 0 ; $i < SQL_nbr_lignes ($resultat) ; $i++)
      {
       $ligne = SQL_ligne_suivante ($resultat) ;
       $r = SQL_commande ("SELECT p.INDNNI FROM F_WIND p, F_DIV c WHERE c.DIVCOD='".$ligne [0]."' AND p.NUMIND=c.NUMIND LIMIT 1", $id_sql) ;
       $pp = SQL_ligne_suivante ($r) ;
       $r = SQL_commande ("INSERT INTO classes (nom,nom_bref,numen_prof_princ,etablissement,signature,periode,num_periode,millesime)
                           VALUES ('".filtrage ($ligne [1])."','".filtrage ($ligne [0])."','".$pp [0]."','".$numero."','1','1','1','".$millesime."')", $id_sql) ;
      }
     $ok_classe = 1 ;
    }
   // Insertion des classes avec profs principaux non renseignes
   $resultat = SQL_commande ("SELECT DIVCOD, DIVLIB FROM F_DIV WHERE NUMIND='' ORDER BY DIVLIB,DIVCOD", $id_sql) ;
   For ($i = 0 ; $i < SQL_nbr_lignes ($resultat) ; $i++)
    {
     $ligne = SQL_ligne_suivante ($resultat) ;
     $r = SQL_commande ("INSERT INTO classes (nom,nom_bref,numen_prof_princ,etablissement,signature,periode,num_periode,millesime)
                         VALUES ('".$ligne [1]."','".$ligne [0]."','','".$numero."','1','1','1','".$millesime."')", $id_sql) ;
    }
 
   // Recherche des profs et insertion
   $r1 = SQL_commande ("SELECT * FROM F_WIND WHERE INDNNI!='' AND AISEXE>0", $id_sql) ;
   // Insertion des profs renseignes
   For ($i = 0 ; $i < SQL_nbr_lignes ($r1) ; $i++)
    {
     $l1 = SQL_tableau_associatif ($r1, "") ;
     Switch (SubStr ($l1 ["AICIVI"], 0, 2))
      {
       Case "M." : $civ = 2 ; Break ;
       Case "MM" : $civ = 0 ; Break ;
       Case "ML" : $civ = 1 ; Break ;
       Default   : $civ = 0 ;
      }
     $r2 = SQL_commande ("SELECT * FROM utilisateurs WHERE numen='".$l1 ["INDNNI"]."'", $id_sql) ;
     If (SQL_nbr_lignes ($r2) == 0)
      {
       $r2 = SQL_commande ("INSERT INTO utilisateurs (nom, prenom, droits, civilite, theme, numen,millesime)
                            VALUES ('".filtrage ($l1 ["AINOMU"])."','".filtrage ($l1 ["AIPREN"])."', '".$droit_prof."','".$civ."','1','".$l1 ["INDNNI"]."','".$millesime."')", $id_sql) ;
      }
   
     // Recupere le nouvel id du professeur
     $r3 = SQL_commande ("SELECT id_utilisateur FROM utilisateurs WHERE numen='".$l1 ["INDNNI"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
     $l3 = SQL_ligne_suivante ($r3) ;
   
     // Recherche discipline du prof et insertion
     $r4 = SQL_commande ("SELECT * FROM F_MEN WHERE NUMIND='".$l1 ["NUMIND"]."' ORDER BY ELSTCO,MATIMN", $id_sql) ;
     If (SQL_nbr_lignes ($r4) > 0)
      {
       $ok_disc++ ;
       For ($j = 0 ; $j < SQL_nbr_lignes ($r4) ; $j++)
        {
         $l4 = SQL_tableau_associatif ($r4, "") ;
         // Recupere le nouveau numero de la discipline
         $r5 = SQL_commande ("SELECT * FROM F_TMT WHERE MATIMN='".filtrage ($l4 ["MATIMN"])."'", $id_sql) ;
         $l5 = SQL_tableau_associatif ($r5, "") ;
         // La discipline est-elle deja enregistree ?
         $r6 = SQL_commande ("SELECT id_discipline FROM disciplines WHERE nom_bref='".filtrage ($l4 ["MATIMN"])."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
         If (SQL_nbr_lignes ($r6) == 0)
          {
           // NON ! donc on enregistre...
           $r7 = SQL_commande ("INSERT INTO disciplines (nom_long,nom_court,nom_bref,code,millesime)
                                VALUES ('".filtrage ($l5 ["MATILL"])."','".filtrage ($l5 ["MATILC"])."',
			                '".filtrage ($l4 ["MATIMN"])."','".filtrage ($l4 ["DISCCO"])."','".$millesime."')", $id_sql) ;
           $r6 = SQL_commande ("SELECT id_discipline FROM disciplines WHERE nom_bref='".filtrage ($l4 ["MATIMN"])."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
          }
         $l5 = SQL_ligne_suivante ($r6) ;
         // Definition service professeur
         If ($l4 ["ELSTTY"] == "D") // Division complete
          {
           $r7 = SQL_commande ("SELECT id_classe FROM classes WHERE nom_bref='".$l4 ["ELSTCO"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
           For ($k = 0 ; $k < SQL_nbr_lignes ($r7) ; $k++)
            {
             $l7 = SQL_ligne_suivante ($r7) ;
             // Recherche double service classe (BIS REPETITAS)
	     // Option ou pas ?
	     If ($l4 ["PRGELE"] == "S") { $option = 0 ; } Else { $option = 1 ; }
	     // Recherche id services classe
             //$r11 = SQL_commande ("SELECT s.id_service_classe
	     //                        FROM services_classe s, disciplines d
	     //                       WHERE s.code_disc='".filtrage ($l4 ["DISCCO"])."'
	     //		  	    AND s.discipline=d.id_discipline
	     //		  	    AND d.nom_bref='".filtrage ($l4 ["MATIMN"])."'
	     //			    AND s.code_classe='".filtrage ($l4 ["ELSTCO"])."'
	     //		            AND s.optionnelle='".$option."'
	     //			    AND s.groupe='0' LIMIT 1", $id_sql) ;
             //If (SQL_nbr_lignes ($r11) == 0)
              //{
               $r12 = SQL_commande ("INSERT INTO services_classe (id_service_classe,discipline,code_disc,classe,code_classe,optionnelle,groupe,millesime)
                                     VALUES ('', '".filtrage ($l5 [0])."','".filtrage ($l4 ["DISCCO"])."','".filtrage ($l7 [0])."','".filtrage ($l4 ["ELSTCO"])."','".$option."','0','".$millesime."')", $id_sql) ;
	       // Recherche id services classe
	       $r11 = SQL_commande ("SELECT id_service_classe FROM services_classe
	                              WHERE code_disc='".$l4 ["DISCCO"]."' AND discipline='".$l5 [0]."'
				        AND classe='".$l7 [0]."' AND code_classe='".$l4 ["ELSTCO"]."'
			                AND optionnelle='".$option."' AND groupe='0' AND millesime='".$millesime."'", $id_sql) ;
	      //}
             // Id services classe
	     For ($dr = 0 ; $dr < SQL_nbr_lignes ($r11) ; $dr++)
	      {
	       $l11 = SQL_ligne_suivante ($r11) ;
	      }
	     // Recherche double service prof
             //$r9 = SQL_commande ("SELECT id_service_prof FROM services_prof
	     //                      WHERE numen_prof='".$l1 ["INDNNI"]."' AND code_disc='".$l4 ["DISCCO"]."'
	     //		           AND code_classe='".$l4 ["ELSTCO"]."' AND service_classe='".$l11 [0]."'
	     //		  	   AND groupe_classe='0' LIMIT 1", $id_sql) ;
             //If (SQL_nbr_lignes ($r9) == 0)
              //{
	       // Pas de doubles -> on enregistre..
               $r10 = SQL_commande ("INSERT INTO services_prof (professeur,numen_prof,discipline,code_disc,classe,code_classe,service_classe,groupe_classe,coefficient,millesime)
                                     VALUES ('".$l3 [0]."','".$l1 ["INDNNI"]."','".$l5 [0]."',
				             '".filtrage ($l4 ["DISCCO"])."','".filtrage ($l7 [0])."','".filtrage ($l4 ["ELSTCO"])."',
				  	     '".filtrage ($l11 [0])."','0','1','".$millesime."')", $id_sql) ;
              //}
	    }
          }
         Else // Groupe seulement
          {
           // Recherche le code division
           $r7 = SQL_commande ("SELECT * FROM F_GPD WHERE GROCOD='".$l4 ["ELSTCO"]."'", $id_sql) ; // F_GPD
           // Pour chacune des divisions trouvees inserer le service classe pour le groupe
           For ($k = 0 ; $k < SQL_nbr_lignes ($r7) ; $k++)
            {
             $l7 = SQL_tableau_associatif ($r7, "") ;
             // Trouve la classe
             $r8 = SQL_commande ("SELECT id_classe FROM classes WHERE nom_bref='".$l7 ["DIVCOD"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
             $l8 = SQL_ligne_suivante ($r8) ;
             // Recherche id services classe
	     If ($l4 ["PRGELE"] == "S") { $option = 0 ; } Else { $option = 1 ; }
             //$r12 = SQL_commande ("SELECT s.id_service_classe FROM services_classe s, disciplines d
	     //                       WHERE s.code_disc='".filtrage ($l4 ["DISCCO"])."'
	     //			    AND s.discipline=d.id_discipline
	     //			    AND d.nom_bref='".filtrage ($l4 ["MATIMN"])."'
	     //			    AND s.code_classe='".filtrage ($l7 ["DIVCOD"])."'
	     //		            AND s.optionnelle='".$option."'
	     //			    AND s.groupe='1' LIMIT 1", $id_sql) ;
             //If (SQL_nbr_lignes ($r12) == 0)
              //{
	       // Enregistre le service classe
	       $r12 = SQL_commande ("INSERT INTO services_classe (discipline,code_disc,classe,code_classe,optionnelle,groupe,millesime)
                                     VALUES ('".filtrage ($l5 [0])."','".filtrage ($l4 ["DISCCO"])."','".filtrage ($l8 [0])."','".filtrage ($l7 ["DIVCOD"])."','".$option."','1','".$millesime."')", $id_sql) ;
	       // Recherche nouvel id services classe
	       $r12 = SQL_commande ("SELECT id_service_classe FROM services_classe
	                              WHERE code_disc='".filtrage ($l4 ["DISCCO"])."' AND discipline='".filtrage ($l5 [0])."'
		  		        AND classe='".filtrage ($l8 [0])."' AND code_classe='".filtrage ($l7 ["DIVCOD"])."'
			                AND optionnelle='".$option."' AND groupe='1' AND millesime='".$millesime."'", $id_sql) ;
	      //}
	     // Lecture des ID
	     For ($dr = 0 ; $dr < SQL_nbr_lignes ($r12) ; $dr++)
	      {
	       $l12 = SQL_ligne_suivante ($r12) ;
	      }
	     // Recherche double groupe classe AND service_classe='".$l12 [0]."'
	     /*
	     $r11 = SQL_commande ("SELECT id_groupe_classe FROM groupes_classe
	                            WHERE code_groupe='".filtrage ($l4 ["ELSTCO"])."'
	   			      AND code_classe='".filtrage ($l7 ["DIVCOD"])."'
	   			      AND code_disc='".filtrage ($l4 ["DISCCO"])."'   			    
	   		            LIMIT 1", $id_sql) ;
             // Definit le groupe
	     If (SQL_nbr_lignes ($r11) == 0)
	      {
	       */
	       // Insertion du nouveau groupe classe
	       $r11 = SQL_commande ("INSERT INTO groupes_classe (code_groupe,classe,code_classe,discipline,code_disc,service_classe,millesime)
	                             VALUES ('".filtrage ($l4 ["ELSTCO"])."','".filtrage ($l8 [0])."','".filtrage ($l7 ["DIVCOD"])."','".$l5 [0]."','".filtrage ($l4 ["DISCCO"])."',
				      '".$l12 [0]."','".$millesime."')", $id_sql) ;
	       // Recherche id groupe classe
	       $r11 = SQL_commande ("SELECT MAX(id_groupe_classe) FROM groupes_classe
	                              WHERE code_groupe='".filtrage ($l4 ["ELSTCO"])."' AND code_classe='".filtrage ($l7 ["DIVCOD"])."'
				        AND code_disc='".filtrage ($l4 ["DISCCO"])."' AND service_classe='".$l12 [0]."' AND millesime='".$millesime."'", $id_sql) ;
	      //}
	     // Lecture des ID
	     For ($dr = 0 ; $dr < SQL_nbr_lignes ($r11) ; $dr++)
	      {
	       $l11 = SQL_ligne_suivante ($r11) ;
	      }
	     // Recherche double service prof professeur='".$l3 [0]."' AND discipline='".$l5 [0]."' AND classe='".$l8 [0]."'
             //$r9 = SQL_commande ("SELECT id_service_prof FROM services_prof
	     //                     WHERE numen_prof='".$l1 ["INDNNI"]."'
	     //		          AND code_disc='".filtrage ($l4 ["DISCCO"])."'
	     //		          AND code_classe='".filtrage ($l7 ["DIVCOD"])."'
	     //		  	  AND service_classe='".$l12 [0]."'
	     //		  	  AND groupe_classe='".$l11 [0]."' LIMIT 1", $id_sql) ;
             //If (SQL_nbr_lignes ($r9) == 0)
              //{
	       // Pas de double -> on enregistre...
               $r10 = SQL_commande ("INSERT INTO services_prof (professeur,numen_prof,discipline,code_disc,classe,code_classe,service_classe,groupe_classe,coefficient,millesime)
                                     VALUES ('".$l3 [0]."','".$l1 ["INDNNI"]."','".$l5 [0]."','".filtrage ($l4 ["DISCCO"])."',
				             '".$l8 [0]."','".filtrage ($l7 ["DIVCOD"])."','".$l12 [0]."','".$l11 [0]."','1','".$millesime."')", $id_sql) ;
              //}
	    }
          }
        }
      }
    }
   // Aucune disciplines renseignees
   If ($ok_disc == 0)
    {
     // Pas de disciplines professeurs renseignees
     $r4 = SQL_commande ("SELECT * FROM F_MEN ORDER BY MATIMN", $id_sql) ; // F_MEN
     For ($j = 0 ; $j < SQL_nbr_lignes ($r4) ; $j++)
      {
       $l4 = SQL_tableau_associatif ($r4, "") ;
       // Recupere le nouveau numero de la discipline
       $r5 = SQL_commande ("SELECT * FROM F_TMT WHERE MATIMN='".filtrage ($l4 ["MATIMN"])."'", $id_sql) ; // F_TMT
       $l5 = SQL_tableau_associatif ($r5, "") ;
       // La discipline est-elle deja enregistree ?
       $r6 = SQL_commande ("SELECT id_discipline FROM disciplines WHERE nom_bref='".filtrage ($l4 ["MATIMN"])."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
       If (SQL_nbr_lignes ($r6) == 0)
        {
         // NON ! donc on enregistre...
          $r7 = SQL_commande ("INSERT INTO disciplines (nom_long,nom_court,nom_bref,code,millesime)
                               VALUES ('".filtrage ($l5 ["MATILL"])."','".filtrage ($l5 ["MATILC"])."','".filtrage ($l4 ["MATIMN"])."','".filtrage ($l4 ["DISCCO"])."','".$millesime."')", $id_sql) ;
          $r6 = SQL_commande ("SELECT id_discipline FROM disciplines WHERE nom_bref='".filtrage ($l4 ["MATIMN"])."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
        }
       $l5 = SQL_ligne_suivante ($r6) ;
       // Definition service professeur
       If ($l4 ["ELSTTY"] == "D") // Division complete
        {
         $r7 = SQL_commande ("SELECT id_classe FROM classes WHERE nom_bref='".$l4 ["ELSTCO"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
         For ($k = 0 ; $k < SQL_nbr_lignes ($r7) ; $k++)
          {
           $l7 = SQL_ligne_suivante ($r7) ;
           // Recherche double service classe (BIS REPETITAS)
           // Option ou pas ?
           If ($l4 ["PRGELE"] == "S") { $option = 0 ; } Else { $option = 1 ; }
           $r12 = SQL_commande ("INSERT INTO services_classe (id_service_classe,discipline,code_disc,classe,code_classe,optionnelle,groupe,millesime)
                                 VALUES ('', '".filtrage ($l5 [0])."','".filtrage ($l4 ["DISCCO"])."','".filtrage ($l7 [0])."','".filtrage ($l4 ["ELSTCO"])."','".$option."', '0','".$millesime."')", $id_sql) ;
	   // Recherche id services classe
	   $r11 = SQL_commande ("SELECT id_service_classe FROM services_classe
	                           WHERE code_disc='".$l4 ["DISCCO"]."' AND discipline='".$l5 [0]."'
	 			    AND classe='".$l7 [0]."' AND code_classe='".$l4 ["ELSTCO"]."'
	 		            AND optionnelle='".$option."' AND groupe='0' AND millesime='".$millesime."'", $id_sql) ;
            // Id services classe
	    For ($dr = 0 ; $dr < SQL_nbr_lignes ($r11) ; $dr++)
	     {
	      $l11 = SQL_ligne_suivante ($r11) ;
	     }
	    // Service prof vierge
            $r10 = SQL_commande ("INSERT INTO services_prof (professeur,numen_prof,discipline,code_disc,classe,code_classe,service_classe,groupe_classe,coefficient,millesime)
                                  VALUES ('0','','".$l5 [0]."','".filtrage ($l4 ["DISCCO"])."','".filtrage ($l7 [0])."','".filtrage ($l4 ["ELSTCO"])."','".filtrage ($l11 [0])."','0','1','".$millesime."')", $id_sql) ;
          }
        }
       Else // Groupe seulement
        {
         // Recherche le code division
         $r7 = SQL_commande ("SELECT * FROM F_GPD WHERE GROCOD='".$l4 ["ELSTCO"]."'", $id_sql) ; // F_GPD
         // Pour chacune des divisions trouvees inserer le service classe pour le groupe
         For ($k = 0 ; $k < SQL_nbr_lignes ($r7) ; $k++)
          {
           $l7 = SQL_tableau_associatif ($r7, "") ;
           // Trouve la classe
           $r8 = SQL_commande ("SELECT id_classe FROM classes WHERE nom_bref='".$l7 ["DIVCOD"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
           $l8 = SQL_ligne_suivante ($r8) ;
           // Recherche id services classe
 	   If ($l4 ["PRGELE"] == "S") { $option = 0 ; } Else { $option = 1 ; }
	   $r12 = SQL_commande ("INSERT INTO services_classe (discipline,code_disc,classe,code_classe,optionnelle,groupe,millesime)
                                 VALUES ('".filtrage ($l5 [0])."','".filtrage ($l4 ["DISCCO"])."','".filtrage ($l8 [0])."','".filtrage ($l7 ["DIVCOD"])."','".$option."', '1','".$millesime."')", $id_sql) ;
	   // Recherche nouvel id services classe
	   $r12 = SQL_commande ("SELECT id_service_classe FROM services_classe
	                          WHERE code_disc='".filtrage ($l4 ["DISCCO"])."' AND discipline='".filtrage ($l5 [0])."'
	 			   AND classe='".filtrage ($l8 [0])."' AND code_classe='".filtrage ($l7 ["DIVCOD"])."'
	 		           AND optionnelle='".$option."' AND groupe='1' AND millesime='".$millesime."'", $id_sql) ;
	   // Lecture des ID
	   For ($dr = 0 ; $dr < SQL_nbr_lignes ($r12) ; $dr++)
	    {
 	     $l12 = SQL_ligne_suivante ($r12) ;
	    }
	   // Insertion du nouveau groupe classe
	   $r11 = SQL_commande ("INSERT INTO groupes_classe (code_groupe,classe,code_classe,discipline,code_disc,service_classe,millesime)
	                         VALUES ('".filtrage ($l4 ["ELSTCO"])."','".filtrage ($l8 [0])."','".filtrage ($l7 ["DIVCOD"])."','".$l5 [0]."', '".filtrage ($l4 ["DISCCO"])."','".$l12 [0]."','".$millesime."')", $id_sql) ;
	   // Recherche id groupe classe
	   $r11 = SQL_commande ("SELECT MAX(id_groupe_classe) FROM groupes_classe
	                          WHERE code_groupe='".filtrage ($l4 ["ELSTCO"])."' AND code_classe='".filtrage ($l7 ["DIVCOD"])."'
	  			   AND code_disc='".filtrage ($l4 ["DISCCO"])."' AND service_classe='".$l12 [0]."' AND millesime='".$millesime."'", $id_sql) ;
	   // Lecture des ID
	   For ($dr = 0 ; $dr < SQL_nbr_lignes ($r11) ; $dr++)
	    {
	     $l11 = SQL_ligne_suivante ($r11) ;
	    }
	   $r10 = SQL_commande ("INSERT INTO services_prof (professeur,numen_prof,discipline,code_disc,classe,code_classe,service_classe,groupe_classe,coefficient,millesime)
                                 VALUES ('0','','".$l5 [0]."','".filtrage ($l4 ["DISCCO"])."','".$l8 [0]."','".filtrage ($l7 ["DIVCOD"])."','".$l12 [0]."','".$l11 [0]."','1','".$millesime."')", $id_sql) ;
 	  }
        }
      }
    }
 
   // Recherche des eleves/parents et insertion
   $r1 = SQL_commande ("SELECT * FROM F_ELE WHERE (DIVCOD!='' OR DIVCOD_MSO!='') AND (ELEDEE!='' OR ELEDME!='') AND ELEDSE=''", $id_sql) ;
   If (SQL_nbr_lignes ($r1) > 0)
    {
     For ($i = 0 ; $i < SQL_nbr_lignes ($r1) ; $i++)
      {
       $l1 = SQL_tableau_associatif ($r1, "") ;
     
       If (($l1 ["DIVCOD"]) Or ($l1 ["DIVCOD_MSO"]))
        {
         // Recherche parent
         $r2 = SQL_commande ("SELECT * FROM F_ERE WHERE ERENO='".$l1 ["ERENO"]."' LIMIT 1", $id_sql) ; // F_ERE
         $l2 = SQL_tableau_associatif ($r2, "") ;
    
         // Recherche l'id classe
         If ($l1 ["DIVCOD"]) { $nom_code_classe = $l1 ["DIVCOD"] ; } Else { $nom_code_classe = $l1 ["DIVCOD_MSO"] ; }
         $r3 = SQL_commande ("SELECT id_classe FROM classes WHERE nom_bref='".filtrage ($nom_code_classe)."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
         $l3 = SQL_ligne_suivante ($r3) ;
       
         // Traduit date de naissance
         $date_nais = SubStr ($l1 ["ELEDATNAIS"], 0, 4)."-".SubStr ($l1 ["ELEDATNAIS"], 4, 2)."-".SubStr ($l1 ["ELEDATNAIS"], 6, 2) ;
       
         // Insertion de l'eleve
         // Parent 1
         Switch ($l1 ["ELELI"])
          {
           Case  0 : $civ_parents = "M. et Mme" ; Break ;
           Case  1 : $civ_parents = "M." ; Break ;
           Case  2 : $civ_parents = "Mme" ; Break ;
           Case  7 : If ($l1 ["ELESEXE"] == "M") { $civ_parents = "M." ;} Else { $civ_parents = "Mlle" ; }
                     Break ;
           Default : $civ_parents = "M. et Mme" ; Break ;
          }
         // Parent 2
         Switch ($l1 ["ELEALI"])
          {
           Case  0 : $civ_parents_2 = "M. et Mme" ; Break ;
           Case  1 : $civ_parents_2 = "M." ; Break ;
           Case  2 : $civ_parents_2 = "Mme" ; Break ;
           Case  7 : If ($l1 ["ELESEXE"] == "M") { $civ_parents_2 = "M." ;} Else { $civ_parents_2 = "Mlle" ; }
                     Break ;
           Default : $civ_parents_2 = "" ; Break ;
          }
         $r4 = SQL_commande ("INSERT INTO eleves
                              (exterieur, repere1, repere2, classe, code_classe, sexe, nom, prenoms, date_naissance, redoublant, regime,
			       civilite_parents, nom_parents, prenom_parents, adresse1, adresse2, cp, ville, telephone, telephone_travail,
			       lieu_naissance, etablissement_precedent, civilite_parents_p2, nom_parents_p2, prenom_parents_p2, adresse1_p2,adresse2_p2,
			       cp_p2, ville_p2,telephone_p2, telephone_travail_p2,millesime)
                              VALUES
			      ('0', '".$l1 ["ELENOET"]."', '".$l1 ["ELENONAT"]."', '".$l3 [0]."',
			       '".filtrage ($l1 ["DIVCOD"])."', '".$l1 ["ELESEXE"]."',
			       '".filtrage ($l1 ["ELENOM"])."', '".filtrage ($l1 ["ELEPRE"])."',
			       '".$date_nais."', '".$l1 ["ELEDOUBL"]."', '".$l1 ["ELEREG"]."', '".$civ_parents."',
			       '".filtrage ($l2 ["ERENOM"])."',
			       '".filtrage ($l2 ["EREPRE"])."', '".filtrage ($l2 ["EREADR"])."',
			       '".filtrage ($l2 ["EREADRS"])."', '".$l2 ["ERECLD"]."',
			       '".filtrage ($l2 ["ERELCOM"])."', '".$l2 ["EREPP1"]."', '".$l2 ["EREEP1"]."',
			       '".filtrage ($l1 ["ELELNAIS"])."', '".filtrage ($l1 ["ETOCOD_AD"])."','".$civ_parents_2."',
			       '".filtrage ($l2 ["EREANOM"])."', '".filtrage ($l2 ["EREAPRE"])."',
			       '".filtrage ($l2 ["EREAADR"])."','','".filtrage ($l2 ["EREACLD"])."',
			       '".filtrage ($l2 ["EREALCOM"])."', '".filtrage ($l2 ["EREPP2"])."',
			       '".filtrage ($l2 ["EREEP2"])."','".$millesime."')", $id_sql) ;
    
         // Recherche des options et insertion
         For ($j = 1 ; $j <= 12 ; $j++)
          {
           $nom = "ELEOPT".$j ;
           Eval ("\$nom = \"$nom\" ;") ;
           If (StrLen ($l1 [$nom]) > 0)
            {
             // Recherche l'id de l'eleve
             $r5 = SQL_commande ("SELECT id_eleve FROM eleves WHERE repere1='".$l1 ["ELENOET"]."' AND repere2='".$l1 ["ELENONAT"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
             $l5 = SQL_ligne_suivante ($r5) ;
           
             $r6 = SQL_commande ("SELECT id_discipline,code FROM disciplines WHERE nom_bref='".filtrage ($l1 [$nom])."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
             $l6 = SQL_ligne_suivante ($r6) ;
    
             $r7 = SQL_commande ("SELECT id_service_classe FROM services_classe WHERE classe='".$l3 [0]."' AND discipline='".$l6 [0]."' AND millesime='".$millesime."'", $id_sql) ;
             $l7 = SQL_ligne_suivante ($r7) ;
         
             $r8 = SQL_commande ("INSERT INTO options_eleve (id_option_eleve,eleve,repere1,repere2,discipline,code_disc,service_classe,millesime)
	  		          VALUES ('','".$l5 [0]."','".$l1 ["ELENOET"]."','".$l1 ["ELENONAT"]."','".$l6 [0]."','".filtrage ($l6 [1])."','".$l7 [0]."','".$millesime."')", $id_sql) ;
            }
          }
        }
      }
     $ok_eleve = 1 ;
    }
   Else
    {
     // Aucun code de division mais des eleves presents
     $r1 = SQL_commande ( "SELECT * FROM F_ELE ORDER BY ELENOM,ELEPRE", $id_sql) ; // F_ELE
     For ($i = 0 ; $i < SQL_nbr_lignes ($r1) ; $i++)
      {
       $l1 = SQL_tableau_associatif ($r1, "") ;
       
       // Recherche parent
       $r2 = SQL_commande ("SELECT * FROM F_ERE WHERE ERENO='".$l1 ["ERENO"]."' LIMIT 1", $id_sql) ; // F_ERE
       $l2 = SQL_tableau_associatif ($r2, "") ;
  
       // Pas d'id de classe
     
       // Traduit date de naissance
       $date_nais = SubStr ($l1 ["ELEDATNAIS"], 0, 4)."-".SubStr ($l1 ["ELEDATNAIS"], 4, 2)."-".SubStr ($l1 ["ELEDATNAIS"], 6, 2) ;
     
       // Insertion de l'eleve
       Switch ($l1 ["ELELI"])
        {
         Case  0 : $civ_parents = "M. et Mme" ; Break ;
         Case  1 : $civ_parents = "M." ; Break ;
         Case  2 : $civ_parents = "Mme" ; Break ;
         Case  7 : If ($l1 ["ELESEXE"] == "M") { $civ_parents = "M." ;} Else { $civ_parents = "Mlle" ; }
                   Break ;
         Default : $civ_parents = "M. et Mme" ; Break ;
        }
       $r4 = SQL_commande ("INSERT INTO eleves
                             (exterieur, repere1, repere2, classe, code_classe, sexe, nom, prenoms, date_naissance, redoublant, regime,
			      civilite_parents, nom_parents, prenom_parents, adresse1, adresse2, cp, ville, telephone, telephone_travail,
			      lieu_naissance, etablissement_precedent, nom_parents_p2, prenom_parents_p2, adresse1_p2,adresse2_p2,cp_p2,
			      ville_p2,telephone_p2, telephone_travail_p2,millesime)
                            VALUES
			     ('0','".$l1 ["ELENOET"]."','".$l1 ["ELENONAT"]."','0','','".$l1 ["ELESEXE"]."',
			      '".filtrage ($l1 ["ELENOM"])."', '".filtrage ($l1 ["ELEPRE"])."',
			      '".$date_nais."', '".$l1 ["ELEDOUBL"]."', '".$l1 ["ELEREG"]."', '".$civ_parents."',
			      '".filtrage ($l2 ["ERENOM"])."',
			      '".filtrage ($l2 ["EREPRE"])."', '".filtrage ($l2 ["EREADR"])."',
			      '".filtrage ($l2 ["EREADRS"])."', '".$l2 ["ERECLD"]."',
			      '".filtrage ($l2 ["ERELCOM"])."', '".$l2 ["EREPP1"]."', '".$l2 ["EREEP1"]."',
			      '".filtrage ($l1 ["ELELNAIS"])."', '".filtrage ($l1 ["ETOCOD_AD"])."',
			      '".filtrage ($l2 ["EREANOM"])."', '".filtrage ($l2 ["EREAPRE"])."',
			      '".filtrage ($l2 ["EREAADR"])."','','".filtrage ($l2 ["EREACLD"])."',
			      '".filtrage ($l2 ["EREALCOM"])."', '".filtrage ($l2 ["EREPP2"])."',
			      '".filtrage ($l2 ["EREEP2"])."','".$millesime."')", $id_sql) ;
  
       // Recherche des options et insertion
       For ($j = 1 ; $j <= 12 ; $j++)
        {
         $nom = "ELEOPT".$j ;
         Eval ("\$nom = \"$nom\" ;") ;
         If (StrLen ($l1 [$nom]) > 0)
          {
           // Recherche l'id de l'eleve
           $r5 = SQL_commande ("SELECT id_eleve FROM eleves WHERE repere1='".$l1 ["ELENOET"]."' AND repere2='".$l1 ["ELENONAT"]."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
           $l5 = SQL_ligne_suivante ($r5) ;
         
           $r6 = SQL_commande ("SELECT id_discipline,code FROM disciplines WHERE nom_bref='".filtrage ($l1 [$nom])."' AND millesime='".$millesime."' LIMIT 1", $id_sql) ;
           $l6 = SQL_ligne_suivante ($r6) ;

           $r7 = SQL_commande ("SELECT id_service_classe FROM services_classe WHERE classe='".$l3 [0]."' AND discipline='".$l6 [0]."' AND millesime='".$millesime."'", $id_sql) ;
           $l7 = SQL_ligne_suivante ($r7) ;
         
           $r8 = SQL_commande ("INSERT INTO options_eleve (id_option_eleve,eleve,repere1,repere2,discipline,code_disc,service_classe,millesime)
			        VALUES ('','".$l5 [0]."','".$l1 ["ELENOET"]."','".$l1 ["ELENONAT"]."','".$l6 [0]."','".filtrage ($l6 [1])."','".$l7 [0]."','".$millesime."')", $id_sql) ;
          }
        }
      }
    } 

   // Mise a jour des profs principaux
   $pprof = SQL_commande ("SELECT u.id_utilisateur,u.numen,c.id_classe FROM utilisateurs u,classes c WHERE c.numen_prof_princ=u.numen AND c.millesime='".$millesime."'", $id_sql) ;
   For ($i = 0 ; $i < SQL_nbr_lignes ($pprof) ; $i++)
    {
     $pp = SQL_ligne_suivante ($pprof) ;
     $ok = SQL_commande ("UPDATE classes SET id_prof_princ='".$pp [0]."',numen_prof_princ='".$pp [1]."' WHERE id_classe='".$pp [2]."' LIMIT 1", $id_sql) ;
    } 

   $resultats = SQL_commande ("SELECT * FROM menus WHERE numero='".$droit_courant."' AND ordre='0'", $id_sql) ;
   $l = SQL_tableau_associatif ($resultats, "") ; 
   Echo "<HTML><HEAD>" ;
   entete_html ("Garennes", "travail", 1) ;
   Echo styles ("none", "none", "none", $l ["lien"], "none") ;
   Echo "</HEAD>" ;
 
   Echo "<BODY BACKGROUND=\"../images/fond.png\" TEXT=\"#000000\" onContextMenu=\"return false\">" ;
   Echo "<CENTER><FONT COLOR=\"#0000FF\">Insertion&nbsp;d'une&nbsp;base&nbsp;provenant&nbsp;de&nbsp;GEP&nbsp;(3/3)</FONT></CENTER>" ;
   Echo "<TABLE BORDER=\"1\" BGCOLOR=\"".$l ["couleur_fond"]."\" CELLPADDING=\"0\" CELLSPACING=\"0\" ALIGN=\"CENTER\" STYLE=\"border:1px solid #000000;border-collapse:collapse\">" ;
   Echo "<TR><TD>" ;
   Echo "<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"100%\" STYLE=\"border-collapse:collapse\">" ;
   Echo "<TR><TD COLSPAN=\"2\">" ;
   Echo "<BR><CENTER>&nbsp;Importation GEP effectu&eacute;e&nbsp;</CENTER><BR><BR>" ;
   Echo "&nbsp;Vous pouvez commencer &agrave; utiliser Garennes.&nbsp;<BR>" ;
   If (($ok_etab == 0) Or ($ok_classe == 0) Or ($ok_disc == 0) Or ($ok_eleve == 0)) { Echo "<BR>&nbsp;<B>ATTENTION&nbsp;:</B><BR>" ; }
   If ($ok_etab == 0) { Echo "<BR>&nbsp;-&nbsp;Vous devez renommer votre &eacute;tablisement car dans GEP rien n'est renseign&eacute;&nbsp;! (Connexion&nbsp;Direction&nbsp;->&nbsp;Menu&nbsp;Param&ecirc;tres&nbsp;->&nbsp;&Eacute;tablissements&nbsp;->&nbsp;<IMG SRC=\"../images/edition.png\" BORDER=\"0\">)&nbsp;<BR>" ; }
   If ($ok_classe == 0) { Echo "<BR>&nbsp;-&nbsp;Vous devez renseigner les professeurs principaux car dans GEP il n'y a aucun enregistrement&nbsp;! (Connexion&nbsp;Direction&nbsp;ou&nbsp;Secr&eacute;tariat&nbsp;->&nbsp;Menu&nbsp;Gestion&nbsp;->&nbsp;Classes&nbsp;->&nbsp;<IMG SRC=\"../images/fiche.png\" BORDER=\"0\">)&nbsp;<BR>" ; }
   If ($ok_disc == 0) { Echo "<BR>&nbsp;-&nbsp;Vous devez renseigner toutes les disciplines car dans GEP il n'y a aucun emploi du temps&nbsp;! (Connexion&nbsp;Direction&nbsp;ou&nbsp;Secr&eacute;tariat&nbsp;->&nbsp;Menu&nbsp;Gestion&nbsp;->&nbsp;Classes&nbsp;->&nbsp;<IMG SRC=\"../images/fiche.png\" BORDER=\"0\">)&nbsp;<BR>" ; }
   If ($ok_eleve == 0) { Echo "<BR>&nbsp;-&nbsp;Vous devez renseigner toutes les classes des &eacute;l&egrave;ves car dans GEP les classes ne sont pas positionn&eacute;es&nbsp;! (Connexion&nbsp;Direction&nbsp;ou&nbsp;Secr&eacute;tariat&nbsp;->&nbsp;Menu&nbsp;Gestion&nbsp;->&nbsp;&Eacute;l&egrave;ves&nbsp;->&nbsp;<IMG SRC=\"../images/fiche.png\" BORDER=\"0\">)&nbsp;<BR>" ; }
   Echo "<BR></TD></TR></TABLE>" ;
   Echo "</TD></TR></TABLE>" ;
   Echo "</BODY></HTML>" ;
  }
 Else
  {
   // Message d'erreur
   $resultats = SQL_commande ("SELECT * FROM menus WHERE numero='".$droit_courant."' AND ordre='0'", $id_sql) ;
   $l = SQL_tableau_associatif ($resultats, "") ; 
   Echo "<HTML><HEAD>" ;
   entete_html ("Garennes", "travail", 1) ;
   Echo styles ("none", "none", "none", $l ["lien"], "none") ;
   Echo "</HEAD>" ;
 
   Echo "<BODY BACKGROUND=\"../images/fond.png\" TEXT=\"#000000\" onContextMenu=\"return false\">" ;
   Echo "<CENTER><FONT COLOR=\"#0000FF\">Insertion&nbsp;d'&eacute;l&egrave;ves&nbsp;provenant&nbsp;de&nbsp;GEP&nbsp;(3/3)</FONT></CENTER>" ;
   Echo "<br><br><center><font color=\"#FF0000\">".$message."</font></center>" ;
   Echo "</BODY></HTML>" ;
  }
 // Destruction des tables GEP temporaires
 For ($i = 1 ; $i <= $table [0] ; $i++)
  {
   $ok = SQL_commande ("DROP TABLE ".$table [$i], $id_sql) ;
  }
?>